
#include "filedirs.h"
#include "gmonsters.h"
#include <stdlib.h>

#define gm_ability_not_multi(a) (a == 0 || a->effects[0].func != &gm_ability_multihit)
#define GM_NOA 69

void gm_ability_fear(GMAbility *, gpointer, gpointer);
void gm_ability_stun(GMAbility *, gpointer, gpointer);
void gm_ability_sleep(GMAbility *, gpointer, gpointer);
void gm_ability_confusion(GMAbility *, gpointer, gpointer);
void gm_ability_poison(GMAbility *, gpointer, gpointer);
void gm_ability_leech(GMAbility *, gpointer, gpointer);
void gm_ability_counter(GMAbility *, gpointer, gpointer);
void gm_ability_absorb_hp(GMAbility *, gpointer, gpointer);
void gm_ability_absorb_str(GMAbility *, gpointer, gpointer);
void gm_ability_raise_str(GMAbility *, gpointer, gpointer);
void gm_ability_raise_def(GMAbility *, gpointer, gpointer);
void gm_ability_raise_spd(GMAbility *, gpointer, gpointer);
void gm_ability_raise_int(GMAbility *, gpointer, gpointer);
void gm_ability_raise_acc(GMAbility *, gpointer, gpointer);
void gm_ability_raise_rand(GMAbility *, gpointer, gpointer);
void gm_ability_lower_str(GMAbility *, gpointer, gpointer);
void gm_ability_lower_def(GMAbility *, gpointer, gpointer);
void gm_ability_lower_spd(GMAbility *, gpointer, gpointer);
void gm_ability_lower_int(GMAbility *, gpointer, gpointer);
void gm_ability_lower_acc(GMAbility *, gpointer, gpointer);
void gm_ability_multihit(GMAbility *, gpointer, gpointer);
void gm_ability_mimic(GMAbility *, gpointer, gpointer);
void gm_ability_segfault(GMAbility *, gpointer, gpointer);

void gm_ability_anim_hit(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_cut(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_shock(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_water(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_flame(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_slam(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_psyhit(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_psy(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_drain(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_frost(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_spinhit(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_spincut(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_gust(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_farhit(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_beam(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);
void gm_ability_anim_blob(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);

/*
 * format is {type, name, animfunc, damage, chance, cost, recovery,
 * no_effect, noe, funcs} 
 */

GMAbility gm_ability[GM_NOA] = { {0, "Tackle", &gm_ability_anim_hit, GM_PHYSICAL, 2, 0, 2, 0, FALSE, 0,
								  {{0}}},
{0, "Scratch", &gm_ability_anim_cut, GM_PHYSICAL, 3, 0, 4, 0, FALSE, 0,
 {{0}}},
{0, "Bite", &gm_ability_anim_hit, GM_PHYSICAL, 2, 50, 3, 0, FALSE, 1,
 {{TRUE, &gm_ability_fear}}},
{GM_FIGHTING, "Punch", &gm_ability_anim_hit, GM_PHYSICAL, 2, 0, 2, 0, FALSE,
 0, {{0}}},
{GM_FIGHTING, "Kick", &gm_ability_anim_hit, GM_PHYSICAL, 2, 50, 2, 0, FALSE,
 1, {{TRUE, &gm_ability_stun}}},
{0, "Rage", &gm_ability_anim_hit, GM_PHYSICAL, 4, 50, 10, 0, FALSE, 1,
 {{TRUE, &gm_ability_lower_def}}},
{GM_ELECTRIC, "Shock", &gm_ability_anim_shock, GM_PHYSICAL, 2, 0, 2, 0, FALSE,
 0, {{0}}},
{GM_WATER, "Pressure Spray", &gm_ability_anim_water, GM_PHYSICAL, 2, 0, 2, 0,
 FALSE, 0, {{0}}},
{GM_FIRE, "Flame", &gm_ability_anim_flame, GM_PHYSICAL, 2, 0, 2, 0, FALSE, 0,
 {{0}}},
{GM_FLYING, "Dive Bomb", &gm_ability_anim_slam, GM_PHYSICAL, 2, 50, 4, 0,
 FALSE, 1, {{TRUE, &gm_ability_stun}}},
{GM_STONE, "Crush", &gm_ability_anim_slam, GM_PHYSICAL, 2, 50, 3, 0, FALSE, 1,
 {{TRUE, &gm_ability_lower_spd}}},
{GM_PLANT, "Vines", &gm_ability_anim_hit, GM_PHYSICAL, 2, 0, 2, 0, FALSE, 0,
 {{0}}},
{GM_POISON, "Sting", &gm_ability_anim_hit, GM_PHYSICAL, 2, 50, 3, 0, FALSE, 1,
 {{TRUE, &gm_ability_poison}}},
{GM_INSECT, "Bug Bite", &gm_ability_anim_hit, GM_PHYSICAL, 2, 0, 2, 0, FALSE,
 0, {{0}}},
{GM_PSYCHIC, "Disturb", &gm_ability_anim_psyhit, GM_MENTAL, 2, 50, 2, 0, TRUE,
 1, {{TRUE, &gm_ability_fear}}},
{GM_PSYCHIC, "Concentrate", &gm_ability_anim_psy, GM_PHYSICAL, 0, 0, 5, 0,
 FALSE, 1, {{FALSE, &gm_ability_raise_int}}},
{GM_CYBERNETIC, "Repair", &gm_ability_anim_psy, GM_PHYSICAL, 0, 0, 10, 2,
 FALSE, 0, {{0}}},
{GM_PSYCHIC, "Hypnosis", &gm_ability_anim_psy, GM_PHYSICAL, 0, 0, 10, 0,
 FALSE, 1, {{FALSE, &gm_ability_sleep}}},
{GM_FIGHTING, "Take Down", &gm_ability_anim_hit, GM_PHYSICAL, 4, 0, 4, -1,
 FALSE, 0, {{0}}},
{GM_PSYCHIC, "Distort", &gm_ability_anim_psyhit, GM_MENTAL, 2, 50, 2, 0, TRUE,
 1, {{TRUE, &gm_ability_confusion}}},
{0, "Absorb", &gm_ability_anim_psy, GM_PHYSICAL, 0, 100, 10, 0, FALSE, 1,
 {{FALSE, &gm_ability_absorb_hp}}},
{GM_FIGHTING, "Pump Up", &gm_ability_anim_psy, GM_PHYSICAL, 0, 100, 10, 0,
 FALSE, 1, {{FALSE, &gm_ability_raise_str}}},
{0, "Drain", &gm_ability_anim_drain, GM_PHYSICAL, 2, 0, 10, 1, FALSE, 0,
 {{0}}},
{GM_ELECTRIC, "Bolt", &gm_ability_anim_shock, GM_PHYSICAL, 4, 50, 5, 0, FALSE,
 1, {{TRUE, &gm_ability_stun}}},
{GM_FIRE, "Inferno", &gm_ability_anim_flame, GM_PHYSICAL, 6, 0, 10, 1, FALSE,
 0, {{0}}},
{GM_FLYING, "Flying Slam", &gm_ability_anim_slam, GM_PHYSICAL, 4, 0, 4, 0,
 FALSE, 0, {{0}}},
{GM_PLANT, "Roots", &gm_ability_anim_drain, GM_PHYSICAL, 1, 50, 10, 2, FALSE,
 1, {{TRUE, &gm_ability_lower_def}}},
{GM_ICE, "Frost", &gm_ability_anim_frost, GM_PHYSICAL, 2, 0, 2, 0, FALSE, 0,
 {{0}}},
{GM_POISON, "Venom", &gm_ability_anim_psyhit, GM_PHYSICAL, 0, 100, 10, 0,
 FALSE, 1, {{FALSE, &gm_ability_poison}}},
{GM_ELECTRIC, "Flash", &gm_ability_anim_psy, GM_PHYSICAL, 0, 100, 10, 0,
 FALSE, 3, {{FALSE, &gm_ability_lower_acc}, {TRUE, &gm_ability_stun},
			{TRUE, &gm_ability_confusion}}},
{0, "Counter", &gm_ability_anim_psy, GM_PHYSICAL, 0, 0, 5, 0, FALSE, 1,
 {{FALSE, &gm_ability_counter}}},
{GM_PLANT, "Hallucinogen", &gm_ability_anim_psy, GM_PHYSICAL, 0, 100, 10, 0,
 FALSE, 1, {{FALSE, &gm_ability_confusion}}},
{GM_PSYCHIC, "Psychosis", &gm_ability_anim_psyhit, GM_MENTAL, 3, 50, 5, 0,
 TRUE, 2, {{TRUE, &gm_ability_fear}, {TRUE, &gm_ability_confusion}}},
{0, "Bum Rush", &gm_ability_anim_hit, GM_PHYSICAL, 4, 50, 10, 0, FALSE, 1,
 {{TRUE, &gm_ability_stun}}},
{GM_WATER, "Hydrolaser", &gm_ability_anim_water, GM_PHYSICAL, 4, 50, 10, 0,
 FALSE, 1, {{TRUE, &gm_ability_lower_def}}},
{GM_PLANT, "Caffine", &gm_ability_anim_psy, GM_PHYSICAL, 0, 100, 12, 0, FALSE,
 1, {{FALSE, &gm_ability_raise_spd}}},
{GM_PLANT, "Toxin", &gm_ability_anim_psyhit, GM_PHYSICAL, 0, 100, 10, 0,
 FALSE, 1, {{FALSE, &gm_ability_poison}}},
{GM_FIRE, "Pyrotechnics", &gm_ability_anim_flame, GM_PHYSICAL, 6, 50, 5, 0,
 FALSE, 1, {{TRUE, &gm_ability_fear}}},
{GM_FIGHTING, "Spin Punch", &gm_ability_anim_spinhit, GM_PHYSICAL, 6, 50, 5,
 0, FALSE, 1, {{TRUE, &gm_ability_stun}}},
{GM_FLYING, "Whirlwind", &gm_ability_anim_gust, GM_PHYSICAL, 6, 50, 15, 0,
 FALSE, 1, {{TRUE, &gm_ability_confusion}}},
{GM_FLYING, "Gust", &gm_ability_anim_gust, GM_PHYSICAL, 2, 0, 2, 0, FALSE, 0,
 {{0}}},
{GM_ICE, "Absolute Zero", &gm_ability_anim_frost, GM_PHYSICAL, 2, 0, 5, 0,
 FALSE, 1, {{FALSE, &gm_ability_sleep}}},
{GM_PSYCHIC, "Anger", &gm_ability_anim_psy, GM_PHYSICAL, 0, 100, 15, 0, FALSE,
 1, {{FALSE, &gm_ability_absorb_str}}},
{GM_PSYCHIC, "Scare", &gm_ability_anim_psyhit, GM_PHYSICAL, 0, 50, 10, 0,
 FALSE, 2, {{FALSE, &gm_ability_fear}, {TRUE, &gm_ability_stun}}},
{0, "Spinslice", &gm_ability_anim_spincut, GM_PHYSICAL, 8, 50, 8, 0, FALSE, 1,
 {{TRUE, &gm_ability_lower_def}}},
{0, "Slash", &gm_ability_anim_cut, GM_PHYSICAL, 4, 50, 5, 0, FALSE, 1,
 {{TRUE, &gm_ability_lower_def}}},
{GM_PLANT, "Leaf Knife", &gm_ability_anim_cut, GM_PHYSICAL, 4, 50, 5, 0,
 FALSE, 1, {{TRUE, &gm_ability_lower_def}}},
{0, "Needles", &gm_ability_anim_farhit, GM_PHYSICAL, 1, 0, 4, 0, FALSE, 1,
 {{FALSE, &gm_ability_multihit}}},
{GM_PSYCHIC, "Meditate", &gm_ability_anim_psy, GM_MENTAL, 0, 100, 15, 2,
 FALSE, 1, {{FALSE, &gm_ability_raise_rand}}},
{GM_STONE, "Gravel", &gm_ability_anim_farhit, GM_PHYSICAL, 1, 50, 4, 0, FALSE,
 2, {{FALSE, &gm_ability_multihit}, {TRUE, &gm_ability_stun}}},
{GM_STONE, "Rock Tail", &gm_ability_anim_spinhit, GM_PHYSICAL, 6, 0, 10, 0,
 FALSE, 0, {{0}}},
{GM_CYBERNETIC, "Implant", &gm_ability_anim_psyhit, GM_PHYSICAL, 2, 50, 5, 0,
 FALSE, 2, {{TRUE, &gm_ability_confusion}, {FALSE, &gm_ability_leech}}},
{GM_ICE, "Ice Breath", &gm_ability_anim_frost, GM_PHYSICAL, 1, 50, 3, 0,
 FALSE, 2, {{FALSE, &gm_ability_stun}, {TRUE, &gm_ability_sleep}}},
{GM_ICE, "Snowballs", &gm_ability_anim_frost, GM_PHYSICAL, 1, 0, 5, 0, FALSE,
 1, {{FALSE, &gm_ability_multihit}}},
{GM_FUNGUS, "Latch Spore", &gm_ability_anim_psyhit, GM_PHYSICAL, 2, 0, 5, 0,
 FALSE, 1, {{FALSE, &gm_ability_leech}}},
{GM_FUNGUS, "Chemicals", &gm_ability_anim_psyhit, GM_PHYSICAL, 2, 50, 10, 0,
 FALSE, 4, {{TRUE, &gm_ability_stun}, {TRUE, &gm_ability_fear},
			{TRUE, &gm_ability_sleep}, {TRUE, &gm_ability_confusion}}},
{GM_CYBERNETIC, "Segfault", &gm_ability_anim_psyhit, GM_PHYSICAL, 0, 50, 15,
 0, FALSE, 3, {{FALSE, &gm_ability_segfault}, {TRUE, &gm_ability_lower_acc},
			   {TRUE, &gm_ability_stun}}},
{GM_CYBERNETIC, "Swap File", &gm_ability_anim_psy, GM_MENTAL, 0, 0, 10, 2,
 FALSE, 1, {{FALSE, &gm_ability_lower_int}}},
{GM_CYBERNETIC, "Module", &gm_ability_anim_psy, GM_PHYSICAL, 0, 0, 10, 0,
 FALSE, 1, {{FALSE, &gm_ability_mimic}}},
{GM_PSYCHIC, "Psyshield", &gm_ability_anim_psy, GM_PHYSICAL, 0, 0, 5, 0,
 FALSE, 1, {{FALSE, &gm_ability_raise_def}}},
{GM_CYBERNETIC, "Tracking", &gm_ability_anim_psy, GM_PHYSICAL, 0, 0, 10, 0,
 FALSE, 1, {{FALSE, &gm_ability_raise_acc}}},
{GM_GHOST, "Vapor", &gm_ability_anim_psyhit, GM_PHYSICAL, 2, 50, 3, 0, FALSE, 1,
 {{TRUE, &gm_ability_fear}}},
{GM_GHOST, "Cloud", &gm_ability_anim_psyhit, GM_PHYSICAL, 6, 50, 8, 0, FALSE, 1,
 {{TRUE, &gm_ability_fear}}},
{GM_GHOST, "Nightmare", &gm_ability_anim_psyhit, GM_PSYCHIC, 4, 50, 15, 0, FALSE, 3,
 {{TRUE, &gm_ability_fear}, {TRUE, &gm_ability_confusion}, {TRUE, &gm_ability_stun}}},
{GM_ENERGY, "Lightbeam", &gm_ability_anim_beam, GM_PHYSICAL, 2, 0, 2, 0, FALSE,
 0, {{0}}},
{GM_ENERGY, "Darkbeam", &gm_ability_anim_beam, GM_PHYSICAL, 3, 50, 5, 0, FALSE,
 1, {{TRUE, &gm_ability_lower_acc}}},
{GM_ENERGY, "Ultrabeam", &gm_ability_anim_beam, GM_PHYSICAL, 4, 50, 15, 0, FALSE, 3,
 {{TRUE, &gm_ability_fear}, {TRUE, &gm_ability_lower_acc}, {TRUE, &gm_ability_stun}}},
{GM_ENERGY, "Liquify", &gm_ability_anim_blob, GM_PHYSICAL, 2, 50, 3, 0, FALSE, 1,
 {{TRUE, &gm_ability_fear}}},
{GM_ENERGY, "Blob", &gm_ability_anim_drain, GM_PHYSICAL, 5, 0, 10, 1, FALSE, 0,
 {{0}}}
};

gchar *
gm_class_name(GMClassification klass)
{
	switch (klass) {
	case 0:
		return "normal";
	case GM_STONE:
		return "stone";
	case GM_FLYING:
		return "flying";
	case GM_ELECTRIC:
		return "electric";
	case GM_WATER:
		return "water";
	case GM_FIRE:
		return "fire";
	case GM_POISON:
		return "poison";
	case GM_INSECT:
		return "insect";
	case GM_PLANT:
		return "plant";
	case GM_FIGHTING:
		return "fighting";
	case GM_PSYCHIC:
		return "psychic";
	case GM_FUNGUS:
		return "fungus";
	case GM_NOCTURNAL:
		return "nocturnal";
	case GM_CYBERNETIC:
		return "cybernetic";
	case GM_ICE:
		return "ice";
	case GM_ENERGY:
		return "energy";
	case GM_GHOST:
		return "ghost";
	default:
		return "unknown";
	}
	return 0;
}

GMEffective
gm_class_effective(GMClassification t1, GMClassification t2)
{
	GMClassification super = 0, weak = 0, none = 0;
	if (t1 & GM_STONE) {
		super |= GM_STONE_STRONG;
		weak |= GM_STONE_WEAK;
		none |= GM_STONE_NO_EFFECT;
	}
	if (t1 & GM_FLYING) {
		super |= GM_FLYING_STRONG;
		weak |= GM_FLYING_WEAK;
		none |= GM_FLYING_NO_EFFECT;
	}
	if (t1 & GM_ELECTRIC) {
		super |= GM_ELECTRIC_STRONG;
		weak |= GM_ELECTRIC_WEAK;
		none |= GM_ELECTRIC_NO_EFFECT;
	}
	if (t1 & GM_WATER) {
		super |= GM_WATER_STRONG;
		weak |= GM_WATER_WEAK;
		none |= GM_WATER_NO_EFFECT;
	}
	if (t1 & GM_FIRE) {
		super |= GM_FIRE_STRONG;
		weak |= GM_FIRE_WEAK;
		none |= GM_FIRE_NO_EFFECT;
	}
	if (t1 & GM_POISON) {
		super |= GM_POISON_STRONG;
		weak |= GM_POISON_WEAK;
		none |= GM_POISON_NO_EFFECT;
	}
	if (t1 & GM_INSECT) {
		super |= GM_INSECT_STRONG;
		weak |= GM_INSECT_WEAK;
		none |= GM_INSECT_NO_EFFECT;
	}
	if (t1 & GM_PLANT) {
		super |= GM_PLANT_STRONG;
		weak |= GM_PLANT_WEAK;
		none |= GM_PLANT_NO_EFFECT;
	}
	if (t1 & GM_FIGHTING) {
		super |= GM_FIGHTING_STRONG;
		weak |= GM_FIGHTING_WEAK;
		none |= GM_FIGHTING_NO_EFFECT;
	}
	if (t1 & GM_PSYCHIC) {
		super |= GM_PSYCHIC_STRONG;
		weak |= GM_PSYCHIC_WEAK;
		none |= GM_PSYCHIC_NO_EFFECT;
	}
	if (t1 & GM_FUNGUS) {
		super |= GM_FUNGUS_STRONG;
		weak |= GM_FUNGUS_WEAK;
		none |= GM_FUNGUS_NO_EFFECT;
	}
	if (t1 & GM_NOCTURNAL) {
		super |= GM_NOCTURNAL_STRONG;
		weak |= GM_NOCTURNAL_WEAK;
		none |= GM_NOCTURNAL_NO_EFFECT;
	}
	if (t1 & GM_CYBERNETIC) {
		super |= GM_CYBERNETIC_STRONG;
		weak |= GM_CYBERNETIC_WEAK;
		none |= GM_CYBERNETIC_NO_EFFECT;
	}
	if (t1 & GM_ICE) {
		super |= GM_ICE_STRONG;
		weak |= GM_ICE_WEAK;
		none |= GM_ICE_NO_EFFECT;
	}
	if (t2 & super || (t2 == 0 && (t1 & GM_FIGHTING || t1 & GM_NOCTURNAL)))
		return GM_SUPER;
	if (t2 & weak || (t1 == 0 && t2 & GM_STONE))
		return GM_WEAK;
	if (t2 & none)
		return GM_NO_EFFECT;
	return GM_MEDIUM;
}

GMAbility *
gm_ability_get_list()
{
	return gm_ability;
}

guint
gm_ability_list_length()
{
	return GM_NOA;
}

GMAbility *
gm_ability_match(gchar * name)
{
	guint a;
	for (a = 0; a < GM_NOA; a++)
		if (!strcmp(gm_ability[a].name, name))
			return gm_ability + a;
	return 0;
}

void
gm_ability_call(gchar * name, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	GtkWidget *canvas = (one->window != NULL) ? GM_BATTLE_WINDOW(one->window)->canvas : 0;
	GMAbility *abl = gm_ability_match(name);
	gchar *strng;
	guint dmgd;
	gint a;
	if (abl != 0) {
		one->monster->ap -= abl->cost;
		if (gm_class_effective(abl->type, two->monster->spec->type) == GM_NO_EFFECT || (abl->no_effect == TRUE && gm_class_effective(abl->type, two->monster->spec->type) == GM_WEAK)) {
			strng = "It has no effect!\n";
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		} else if (abl->damage > 0 && gm_ability_not_multi(abl)) {
			if (one->window != NULL)
				abl->animfunc(canvas, one->pic, two->pic, one->side);
			if (gm_rand(one->acc) < 5) {
				strng = g_strdup_printf("%s's attack missed...\n", one->monster->name);
				if (one->window != NULL)
					gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
				free(strng);
				return;
			}
			if (gm_class_effective(abl->type, two->monster->spec->type)
				== GM_WEAK) {
				strng = "It's not very effective...\n";
				if (one->window != NULL)
					gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			} else if (gm_class_effective(abl->type, two->monster->spec->type) == GM_SUPER) {
				strng = "It's super effective!\n";
				if (one->window != NULL)
					gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			}
			dmgd = 0;
			for (a = 0; a < abl->damage / 2; a++)
				dmgd += gm_battle_effects_deal_damage(two, abl->type, (abl->dmgtype == GM_PHYSICAL ? gm_monster_str(one->monster, one->str) : gm_monster_int(one->monster, one->wis)), abl->dmgtype);
			if (abl->damage % 2 == 1)
				dmgd += gm_battle_effects_deal_damage(two, abl->type, (abl->dmgtype == GM_PHYSICAL ? gm_monster_str(one->monster, one->str) : gm_monster_int(one->monster, one->wis))
													  / 2, abl->dmgtype);
			if (abl->recovery > 0) {
				strng = g_strdup_printf("%s absorbed health!\n", one->monster->name);
				if (one->window != NULL)
					gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
				free(strng);
				for (a = 0; a < abl->recovery / 2; a++) {
					if (dmgd + one->monster->hp >= gm_monster_maxhp(one->monster, 0))
						one->monster->hp = gm_monster_maxhp(one->monster, 0);
					else
						one->monster->hp += dmgd;
				}
				if (abl->recovery % 2 == 1) {
					if ((dmgd / 2) + one->monster->hp >= gm_monster_maxhp(one->monster, 0))
						one->monster->hp = gm_monster_maxhp(one->monster, 0);
					else
						one->monster->hp += (dmgd / 2);
				}
			} else if (abl->recovery < 0) {
				strng = g_strdup_printf("%s was hurt by the attack!\n", one->monster->name);
				if (one->window != NULL)
					gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
				free(strng);
				for (a = 0; a < abl->recovery / -2; a++)
					gm_battle_effects_deal_damage(one, abl->type, dmgd, abl->dmgtype);
				if (abl->recovery % -2 == 1)
					gm_battle_effects_deal_damage(one, abl->type, dmgd / 2, abl->dmgtype);
			}
		} else if (abl->recovery > 0) {
			if (one->window != NULL)
				abl->animfunc(canvas, one->pic, two->pic, one->side);
			dmgd = gm_monster_str(one->monster, one->str);
			for (a = 0; a < abl->recovery / 2; a++) {
				if (dmgd + one->monster->hp >= gm_monster_maxhp(one->monster, 0))
					one->monster->hp = gm_monster_maxhp(one->monster, 0);
				else
					one->monster->hp += dmgd;
				if (one->leech == TRUE) {
					if (dmgd + two->monster->hp >= gm_monster_maxhp(two->monster, 0))
						two->monster->hp = gm_monster_maxhp(two->monster, 0);
					else
						two->monster->hp += dmgd;
				}
			}
			if (abl->recovery % 2 == 1) {
				if ((dmgd / 2) + one->monster->hp >= gm_monster_maxhp(one->monster, 0))
					one->monster->hp = gm_monster_maxhp(one->monster, 0);
				else
					one->monster->hp += (dmgd / 2);
				if (one->leech == TRUE) {
					if ((dmgd / 2) + two->monster->hp >= gm_monster_maxhp(two->monster, 0))
						two->monster->hp = gm_monster_maxhp(two->monster, 0);
					else
						two->monster->hp += (dmgd / 2);
				}
			}
		} else if (gm_ability_not_multi(abl))
			if (one->window != NULL)
				abl->animfunc(canvas, one->pic, two->pic, one->side);
		if (abl->noe > 0 && (gm_class_effective(abl->type, two->monster->spec->type) != GM_NO_EFFECT && (abl->no_effect != TRUE || gm_class_effective(abl->type, two->monster->spec->type) == GM_WEAK))) {
			for (a = 0; a < abl->noe; a++) {
				if (gm_rand(100) < abl->chance || abl->effects[a].possible == FALSE)
					abl->effects[a].func(abl, one, two);
			}
		}
	}
}

void
gm_ability_fear(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	two->fear += ((rand() % 3) + 1) * ((rand() % 3) + 3);
	strng = g_strdup_printf("%s is scared!\n", two->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
	free(strng);
}

void
gm_ability_stun(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	if (two->status == GM_NORMAL) {
		two->status = GM_STUN;
		strng = g_strdup_printf("%s is stunned!\n", two->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
		free(strng);
	}
}

void
gm_ability_sleep(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	if (two->status != GM_FAINTED) {
		two->status = GM_SLEEP;
		strng = g_strdup_printf("%s fell asleep!\n", two->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
		free(strng);
	}
}

void
gm_ability_confusion(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	if (two->status == GM_NORMAL) {
		two->status = GM_CONFUSED;
		strng = g_strdup_printf("%s became confused!\n", two->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
		free(strng);
	}
}

void
gm_ability_poison(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	two->poisoned = TRUE;
	strng = g_strdup_printf("%s is poisoned!\n", two->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	else if (two->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
	free(strng);
}

void
gm_ability_leech(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	two->leech = TRUE;
	strng = g_strdup_printf("Leeching off of %s!\n", two->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
	free(strng);
}

void
gm_ability_counter(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	one->eot = GM_COUNTER_ATTACK;
}

void
gm_ability_absorb_hp(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	one->eot = GM_ABSORB_AS_HP;
}

void
gm_ability_absorb_str(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	one->eot = GM_ABSORB_AS_STR;
}

/*
 * void gm_ability_raise_hp(GMAbility *abl, gpointer o, gpointer t, GtkWidget 
 * *text) { GMBattleEffects *one = (GMBattleEffects*)o; gchar *strng;
 * one->maxhp++; strng = g_strdup_printf("%s's maximum health rose!\n",
 * one->monster->name);
 * gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
 * free(strng); }
 */

void
gm_ability_raise_str(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	gchar *strng;
	one->str++;
	strng = g_strdup_printf("%s's strength rose!\n", one->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	free(strng);
}

void
gm_ability_raise_def(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	gchar *strng;
	one->def++;
	strng = g_strdup_printf("%s's defense rose!\n", one->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	free(strng);
}

void
gm_ability_raise_spd(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	gchar *strng;
	one->spd++;
	strng = g_strdup_printf("%s's speed rose!\n", one->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	free(strng);
}

void
gm_ability_raise_int(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	gchar *strng;
	one->wis++;
	strng = g_strdup_printf("%s's intelligence rose!\n", one->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	free(strng);
}

void
gm_ability_raise_acc(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	gchar *strng;
	one->acc += 6 + gm_rand(10);
	strng = g_strdup_printf("%s improved %s aim!\n", one->monster->name, (one->monster->gen == GM_MALE ? "his" : "her"));
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	free(strng);
}

void
gm_ability_raise_rand(GMAbility * abl, gpointer o, gpointer t)
{
	guint rnd = gm_rand(6);
	switch (rnd) {
	case 0:
		/*
		 * gm_ability_raise_hp(abl, o, t); break;
		 */
	case 1:
		gm_ability_raise_str(abl, o, t);
		break;
	case 2:
		gm_ability_raise_def(abl, o, t);
		break;
	case 3:
		gm_ability_raise_spd(abl, o, t);
		break;
	case 4:
		gm_ability_raise_int(abl, o, t);
		break;
	case 5:
		gm_ability_raise_acc(abl, o, t);
		break;
	default:
		break;
	}
}

void
gm_ability_lower_str(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	two->str--;
	strng = g_strdup_printf("Lowered %s's strength!\n", two->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
	free(strng);
}

void
gm_ability_lower_def(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	two->def--;
	strng = g_strdup_printf("Lowered %s's defense!\n", two->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
	free(strng);
}

void
gm_ability_lower_spd(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	two->spd--;
	strng = g_strdup_printf("Lowered %s's speed!\n", two->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
	free(strng);
}

void
gm_ability_lower_int(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	two->wis--;
	strng = g_strdup_printf("Lowered %s's intelligence!\n", two->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
	free(strng);
}

void
gm_ability_lower_acc(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng;
	two->acc -= 2 + gm_rand(9);
	strng = g_strdup_printf("%s was blinded!\n", two->monster->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(two->window), strng);
	free(strng);
}

void
gm_ability_multihit(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	GtkWidget *canvas = GM_BATTLE_WINDOW(one->window)->canvas;
	gchar *strng;
	guint loop, rndnum, hits, a;
	if (gm_class_effective(abl->type, two->monster->spec->type) == GM_WEAK) {
		if (abl->no_effect == FALSE) {
			strng = "It's not very effective...\n";
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		} else {
			strng = "It has no effect!\n";
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			return;
		}
	} else if (gm_class_effective(abl->type, two->monster->spec->type) == GM_SUPER) {
		strng = "It's super effective!\n";
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	}
	rndnum = 2 + gm_rand(9);
	hits = 0;
	for (loop = 0; loop < rndnum; loop++) {
		if (gm_rand(one->acc) >= 5) {
			hits++;
			if (one->window != NULL)
				abl->animfunc(canvas, one->pic, two->pic, one->side);
			for (a = 0; a < abl->damage / 2; a++)
				gm_battle_effects_deal_damage(two, abl->type, (abl->dmgtype == GM_PHYSICAL ? gm_monster_str(one->monster, one->str) : gm_monster_int(one->monster, one->wis)), abl->dmgtype);
			if (abl->damage % 2 == 1)
				gm_battle_effects_deal_damage(two, abl->type, (abl->dmgtype == GM_PHYSICAL ? gm_monster_str(one->monster, one->str) : gm_monster_int(one->monster, one->wis)) / 2, abl->dmgtype);
		}
	}
	strng = g_strdup_printf("Hit %u times!\n", hits);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	free(strng);
}

void
gm_ability_mimic(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	gchar *strng = NULL;
	guint rnd = gm_rand(two->monster->noa);
	one->monster->ap += gm_ability_match(two->monster->abilities[rnd]->name)->cost;
	strng = g_strdup_printf("%s used %s's %s attack!\n", one->monster->name, two->monster->name, two->monster->abilities[rnd]->name);
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	free(strng);
	gm_ability_call(two->monster->abilities[rnd]->name, o, t);
}

void
gm_ability_segfault(GMAbility * abl, gpointer o, gpointer t)
{
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMBattleEffects *two = (GMBattleEffects *) t;
	/*
	 * one->monster->hp -= one->monster->hp - gm_monster_def (one->monster,
	 * one->def); 
	 */
	/*
	 * gm_battle_effects_deal_damage (two, abl->type, two->monster->hp,
	 * abl->dmgtype); 
	 */
	one->monster->hp = gm_monster_def(one->monster, one->def);
	two->monster->hp = gm_monster_def(two->monster, two->def);
}

void
gm_ability_anim_hit(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	guint a;
	if (m1 != NULL) {
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? 5 : -5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? -5 : 5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
	}
}

void
gm_ability_anim_cut(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	guint a;
	if (m1 != NULL) {
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? 5 : -5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? -5 : 5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
	}
}

void
gm_ability_anim_shock(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	static GdkImlibImage *image = NULL;
	gdouble x = GM_PIC_X(side) + (side == GM_LEFT ? 25 : -25);
	GnomeCanvasItem *item;
	guint a;
	if (image == NULL) {
		gchar *tmp = gm_pixmap_file("gm-electric.xpm");
		image = gdk_imlib_load_image(tmp);
		free(tmp);
	}
	item = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(canvas)), gnome_canvas_image_get_type(), "image", image, "x", x, "y", GM_PIC_Y, "width", (double)1, "height", (double)40, "anchor", GTK_ANCHOR_WEST, NULL);
	while (gtk_events_pending())
		gtk_main_iteration();
	for (a = 0; a < 150; a += 5) {
		if (side == GM_RIGHT)
			gnome_canvas_item_set(item, "x", x - a, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		else
			gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(2);
	gtk_object_destroy(GTK_OBJECT(item));
}

void
gm_ability_anim_water(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	static GdkImlibImage *image = NULL;
	gdouble x = GM_PIC_X(side) + (side == GM_LEFT ? 25 : -25);
	GnomeCanvasItem *item;
	guint a;
	if (image == NULL) {
		gchar *tmp = gm_pixmap_file("gm-water.xpm");
		image = gdk_imlib_load_image(tmp);
		free(tmp);
	}
	item = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(canvas)), gnome_canvas_image_get_type(), "image", image, "x", x, "y", GM_PIC_Y, "width", (double)1, "height", (double)40, "anchor", GTK_ANCHOR_WEST, NULL);
	while (gtk_events_pending())
		gtk_main_iteration();
	for (a = 0; a < 150; a += 5) {
		if (side == GM_RIGHT)
			gnome_canvas_item_set(item, "x", x - a, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		else
			gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(2);
	gtk_object_destroy(GTK_OBJECT(item));
}

void
gm_ability_anim_flame(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	static GdkImlibImage *image = NULL;
	gdouble x = GM_PIC_X(side) + (side == GM_LEFT ? 25 : -25);
	GnomeCanvasItem *item;
	guint a;
	if (image == NULL) {
		gchar *tmp = gm_pixmap_file("gm-fire.xpm");
		image = gdk_imlib_load_image(tmp);
		free(tmp);
	}
	item = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(canvas)), gnome_canvas_image_get_type(), "image", image, "x", x, "y", GM_PIC_Y, "width", (double)1, "height", (double)40, "anchor", GTK_ANCHOR_WEST, NULL);
	while (gtk_events_pending())
		gtk_main_iteration();
	for (a = 0; a < 150; a += 5) {
		if (side == GM_RIGHT)
			gnome_canvas_item_set(item, "x", x - a, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		else
			gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(5);
	gtk_object_destroy(GTK_OBJECT(item));
}

void
gm_ability_anim_slam(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	guint a;
	if (m1 != NULL) {
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, 0, -5);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? 5 : -5), 5);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? -5 : 5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
	}
}

void
gm_ability_anim_psyhit(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	static GdkImlibImage *image = NULL;
	gdouble x = GM_PIC_X((side == GM_LEFT ? GM_RIGHT : GM_LEFT));
	GnomeCanvasItem *item;
	guint a;
	if (image == NULL) {
		gchar *tmp = gm_pixmap_file("gm-psychic.xpm");
		image = gdk_imlib_load_image(tmp);
		free(tmp);
	}
	item = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(canvas)), gnome_canvas_image_get_type(), "image", image, "x", x, "y", GM_PIC_Y, "width", (double)1, "height", (double)40, "anchor", GTK_ANCHOR_CENTER, NULL);
	gnome_canvas_item_lower_to_bottom(item);
	while (gtk_events_pending())
		gtk_main_iteration();
	for (a = 0; a < 200; a += 5) {
		gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y + 20, "width", (double)1 + a, "height", (double)1 + a, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(5);
	gnome_canvas_item_raise_to_top(item);
	usleep(5);
	for (a = 200; a > 0; a -= 5) {
		gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y + 20, "width", (double)1 + a, "height", (double)1 + a, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(5);
	gtk_object_destroy(GTK_OBJECT(item));
}

void
gm_ability_anim_psy(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	static GdkImlibImage *image = NULL;
	gdouble x = GM_PIC_X(side);
	GnomeCanvasItem *item;
	guint a;
	if (image == NULL) {
		gchar *tmp = gm_pixmap_file("gm-psychic.xpm");
		image = gdk_imlib_load_image(tmp);
		free(tmp);
	}
	item = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(canvas)), gnome_canvas_image_get_type(), "image", image, "x", x, "y", GM_PIC_Y, "width", (double)1, "height", (double)40, "anchor", GTK_ANCHOR_CENTER, NULL);
	gnome_canvas_item_lower_to_bottom(item);
	while (gtk_events_pending())
		gtk_main_iteration();
	for (a = 0; a < 200; a += 5) {
		gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y + 20, "width", (double)1 + a, "height", (double)1 + a, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(5);
	for (a = 200; a > 0; a -= 5) {
		gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y + 20, "width", (double)1 + a, "height", (double)1 + a, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(5);
	gtk_object_destroy(GTK_OBJECT(item));
}

void
gm_ability_anim_drain(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
}

void
gm_ability_anim_frost(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	static GdkImlibImage *image = NULL;
	gdouble x = GM_PIC_X(side) + (side == GM_LEFT ? 25 : -25);
	GnomeCanvasItem *item;
	guint a;
	if (image == NULL) {
		gchar *tmp = gm_pixmap_file("gm-ice.xpm");
		image = gdk_imlib_load_image(tmp);
		free(tmp);
	}
	item = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(canvas)), gnome_canvas_image_get_type(), "image", image, "x", x, "y", GM_PIC_Y, "width", (double)1, "height", (double)40, "anchor", GTK_ANCHOR_WEST, NULL);
	while (gtk_events_pending())
		gtk_main_iteration();
	for (a = 0; a < 150; a += 5) {
		if (side == GM_RIGHT)
			gnome_canvas_item_set(item, "x", x - a, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		else
			gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(5);
	gtk_object_destroy(GTK_OBJECT(item));
}

void
gm_ability_anim_spinhit(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	guint a;
	if (m1 != NULL) {
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? 5 : -5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? -5 : 5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
	}
}

void
gm_ability_anim_spincut(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	guint a;
	if (m1 != NULL) {
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? 5 : -5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
		for (a = 0; a < 150; a += 5) {
			gnome_canvas_item_move(m1, (side == GM_LEFT ? -5 : 5), 0);
			while (gtk_events_pending())
				gtk_main_iteration();
		}
		usleep(5);
	}
}

void
gm_ability_anim_gust(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	static GdkImlibImage *image = NULL;
	gdouble x = GM_PIC_X(side) + (side == GM_LEFT ? 25 : -25);
	GnomeCanvasItem *item;
	guint a;
	if (image == NULL) {
		gchar *tmp = gm_pixmap_file("gm-flying.xpm");
		image = gdk_imlib_load_image(tmp);
		free(tmp);
	}
	item = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(canvas)), gnome_canvas_image_get_type(), "image", image, "x", x, "y", GM_PIC_Y, "width", (double)1, "height", (double)40, "anchor", GTK_ANCHOR_WEST, NULL);
	while (gtk_events_pending())
		gtk_main_iteration();
	for (a = 0; a < 150; a += 5) {
		if (side == GM_RIGHT)
			gnome_canvas_item_set(item, "x", x - a, "y", GM_PIC_Y, "width", (double)40, "height", (double)40, NULL);
		else
			gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y, "width", (double)40, "height", (double)40, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(2);
	gtk_object_destroy(GTK_OBJECT(item));
}

void
gm_ability_anim_farhit(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
}

void
gm_ability_anim_beam(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
	static GdkImlibImage *image = NULL;
	gdouble x = GM_PIC_X(side) + (side == GM_LEFT ? 25 : -25);
	GnomeCanvasItem *item;
	guint a;
	if (image == NULL) {
		gchar *tmp = gm_pixmap_file("gm-energy.xpm");
		image = gdk_imlib_load_image(tmp);
		free(tmp);
	}
	item = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(canvas)), gnome_canvas_image_get_type(), "image", image, "x", x, "y", GM_PIC_Y, "width", (double)1, "height", (double)40, "anchor", GTK_ANCHOR_WEST, NULL);
	while (gtk_events_pending())
		gtk_main_iteration();
	for (a = 0; a < 150; a += 5) {
		if (side == GM_RIGHT)
			gnome_canvas_item_set(item, "x", x - a, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		else
			gnome_canvas_item_set(item, "x", x, "y", GM_PIC_Y, "width", (double)1 + a, "height", (double)40, NULL);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	usleep(5);
	gtk_object_destroy(GTK_OBJECT(item));
}

void
gm_ability_anim_blob(GtkWidget * canvas, GnomeCanvasItem * m1, GnomeCanvasItem * m2, GMBattleSide side)
{
}
