
#include <gnome.h>
#include "filedirs.h"
#include "gmonsters.h"
#include <stdlib.h>

typedef enum {
	GM_NOT_WON,
	GM_ONE_WON,
	GM_TWO_WON
} GMWon;

gboolean gm_battle_action(guint, GMBattleEffects *, GMBattleEffects *, GMItemList *);
void gm_battle_eot(guint, GMBattleEffects *, GMBattleEffects *);
void gm_battle_player_cb_click_cb(GtkWidget *, guint);
void gm_ability_anim_hit(GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *, GMBattleSide);

guint
gm_battle_effects_deal_damage(GMBattleEffects * def, GMClassification type, guint dmg, GMDamageType dmgtype)
{
	GMEffective eff = gm_class_effective(type, def->monster->spec->type);
	guint dmgc, block = (dmgtype == GM_PHYSICAL ? gm_monster_def(def->monster,
																 def->def) : gm_monster_int(def->monster,
																							def->wis));
	if (eff == GM_NO_EFFECT)
		dmgc = 0;
	else if (eff == GM_WEAK)
		dmgc = ((dmg / 2) <= block ? 1 : (dmg / 2) - block);
	else if (eff == GM_SUPER)
		dmgc = (dmg <= (block / 5) ? 1 : dmg - (block / 5));
	else
		dmgc = (dmg <= (block / 2) ? 1 : dmg - (block / 2));
	if (def->monster->hp <= dmgc) {
		def->monster->hp = 0;
		def->status = GM_FAINTED;
	} else
		def->monster->hp -= dmgc;
	return dmgc;
}

void
gm_battle_struggle(gpointer a, gpointer d)
{
	GMBattleEffects *atk = (GMBattleEffects *) a;
	GMBattleEffects *def = (GMBattleEffects *) d;
	guint dmg = gm_monster_str(atk->monster, atk->str);
	gm_ability_anim_hit(GM_BATTLE_WINDOW(atk->window)->canvas, atk->pic, def->pic, atk->side);
	gm_battle_effects_deal_damage(def, atk->monster->spec->type, dmg, GM_PHYSICAL);
	gm_battle_effects_deal_damage(atk, atk->monster->spec->type, dmg, GM_PHYSICAL);
}

GMOutcome
gm_battle_start(GMTrainer * t1, guint(*ga1) (GMBattleEffects *, gboolean), GMTrainer * t2, guint(*ga2) (GMBattleEffects *, gboolean), gboolean capture, GMBattleType btype, gboolean viewable)
{
	GtkWidget *window = NULL;
	GMBattleEffects *ba1 = malloc(sizeof(GMBattleEffects));
	GMBattleEffects *ba2 = malloc(sizeof(GMBattleEffects));
	gboolean used1[t1->nom + 1];
	gboolean used2[t2->nom + 1];
	GMMonster *m1 = NULL, *m2 = NULL;
	glong m1prev = 0, m2prev = 0;
	GMWon won = GM_NOT_WON;
	GMOutcome retval = GM_NOT_DONE;
	gboolean oneturn = TRUE;
	guint withdraw1 = 0, withdraw2 = 0;
	gchar *strng;
	gint poof;
	gm_rand_init(btype);
	fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Starting battle...\n", getpid(), __LINE__);
	if (viewable == TRUE) {
		window = gm_battle_window_new();
		gtk_widget_show_all(window);
	}
	for(poof = 0; poof < t1->nom; poof++)
		used1[poof] = FALSE;
	for(poof = 0; poof < t2->nom; poof++)
		used2[poof] = FALSE;
	ba1->pic = NULL;
	ba1->side = GM_LEFT;
	ba1->trainer = t1;
	ba1->window = window;
	ba2->pic = NULL;
	ba2->side = GM_RIGHT;
	ba2->trainer = t2;
	ba2->window = window;
	if ((m1 = gm_trainer_select_monster(t1)) == 0)
		won = GM_TWO_WON;
	if ((m2 = gm_trainer_select_monster(t2)) == 0)
		won = GM_ONE_WON;
	if (viewable == TRUE) {
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	while (won == GM_NOT_WON) {
		guint ohp = 0, thp = 0;
		retval = GM_NOT_DONE;
		if (m1->id != m1prev) {
			int a = 0, monnum = 0;
			if (viewable == TRUE) {
				if (ba1->pic != NULL) {
					gtk_object_destroy(GTK_OBJECT(ba1->pic));
					ba1->pic = NULL;
				}
				if (m1->spec->image != NULL) {
					GdkImlibImage *image = gdk_imlib_clone_scaled_image(m1->spec->image,
																		150, 150);
					ba1->pic = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(GM_BATTLE_WINDOW(window)->canvas)), gnome_canvas_image_get_type(), "image", image, "x", GM_PIC_X(ba1->side), "y", GM_PIC_Y, "width", GM_PIC_WIDTH, "height", GM_PIC_HEIGHT, NULL);
				} else
					ba1->pic = NULL;
			} else
				ba1->pic = NULL;
			ohp = m1->hp;
			ba1->monster = m1;
			ba1->status = GM_NORMAL;
			ba1->str = ba1->def = ba1->spd = ba1->wis = 0;
			ba1->fear = 0;
			ba1->acc = 50;
			ba1->wait = 0;
			ba1->poisoned = FALSE;
			ba1->leech = FALSE;
			ba1->eot = GM_EOT_NONE;
			for(a = 0; a < t1->nom; a++)
				if(t1->monsters[a]->id == m1->id)
					monnum = a;
			used1[monnum] = TRUE;
		}
		if (m2->id != m2prev) {
			int a = 0, monnum = 0;
			if (viewable == TRUE) {
				if (ba2->pic != NULL) {
					gtk_object_destroy(GTK_OBJECT(ba2->pic));
					ba2->pic = NULL;
				}
				if (m2->spec->image != NULL) {
					GdkImlibImage *image = gdk_imlib_clone_scaled_image(m2->spec->image,
																		150, 150);
					gdk_imlib_flip_image_horizontal(image);
					ba2->pic = gnome_canvas_item_new(gnome_canvas_root(GNOME_CANVAS(GM_BATTLE_WINDOW(window)->canvas)), gnome_canvas_image_get_type(), "image", image, "x", GM_PIC_X(ba2->side), "y", GM_PIC_Y, "width", GM_PIC_WIDTH, "height", GM_PIC_HEIGHT, NULL);
				} else
					ba2->pic = NULL;
			} else
				ba2->pic = NULL;
			thp = m2->hp;
			ba2->monster = m2;
			ba2->status = GM_NORMAL;
			ba2->str = ba2->def = ba2->spd = ba2->wis = 0;
			ba2->fear = 0;
			ba2->acc = 50;
			ba2->wait = 0;
			ba2->poisoned = FALSE;
			ba2->leech = FALSE;
			ba2->eot = GM_EOT_NONE;
			for(a = 0; a < t2->nom; a++)
				if(t2->monsters[a]->id == m2->id)
					monnum = a;
			used2[monnum] = TRUE;
		}
		m1prev = m1->id;
		m2prev = m2->id;
		if (viewable == TRUE) {
			strng = g_strdup_printf("GMonsters Battle: %s vs. %s", m1->name, m2->name);
			gtk_window_set_title(GTK_WINDOW(window), strng);
			free(strng);
			gm_battle_window_change_monster_one(GM_BATTLE_WINDOW(window), ba1);
			gm_battle_window_change_monster_two(GM_BATTLE_WINDOW(window), ba2);
		}
		while (retval == GM_NOT_DONE) {
			guint one, two;
			if (ba1->status == GM_FAINTED) {
				if (m1->hp == 0) {
					gm_trainer_deactivate(t1, m1->id);
					retval = GM_LOST;
				} else
					retval = GM_WITHDRAWN;
				break;
			} else if (ba2->status == GM_FAINTED) {
				if (m2->hp == 0) {
					gm_trainer_deactivate(t2, m2->id);
					retval = GM_WON;
				} else
					retval = GM_ENEMY_WITHDREW;
				break;
			}
			usleep(1);
			if (oneturn == TRUE) {
				ba1->wait = (ba1->wait + gm_monster_spd(m1, ba1->spd) > 1000 ? 1000 : ba1->wait + gm_monster_spd(m1, ba1->spd));
				if (ba1->fear > 99) {
					if (viewable == TRUE) {
						strng = g_strdup_printf("%s ran away in fear!\n", m1->name);
						gm_battle_window_message(GM_BATTLE_WINDOW(window), strng);
						free(strng);
					}
					ba1->status = GM_FAINTED;
				}
				if (ba1->wait > 999) {
					one = ga1(ba1, capture);
					if (ba1->status != GM_FAINTED && one > 0) {
						gm_battle_eot(thp, ba2, ba1);
						ohp = m1->hp;
					}
					if (gm_battle_action(one, ba1, ba2, NULL) == TRUE)
						retval = GM_CAPTURE;
					ba1->wait = 0;
				}
				oneturn = FALSE;
			} else {
				ba2->wait = (ba2->wait + gm_monster_spd(m2, ba2->spd) > 1000 ? 1000 : ba2->wait + gm_monster_spd(m2, ba2->spd));
				if (ba2->fear > 99) {
					if (viewable == TRUE) {
						strng = g_strdup_printf("%s ran away in fear!\n", m2->name);
						gm_battle_window_message(GM_BATTLE_WINDOW(window), strng);
						free(strng);
					}
					ba2->status = GM_FAINTED;
				}
				if (ba2->wait > 999) {
					two = ga2(ba2, FALSE);
					if (ba2->status != GM_FAINTED && two > 0) {
						gm_battle_eot(ohp, ba1, ba2);
						thp = m2->hp;
					}
					gm_battle_action(two, ba2, ba1, NULL);
					ba2->wait = 0;
				}
				oneturn = TRUE;
			}
			if (viewable == TRUE) {
				gm_battle_window_set_hp_one(GM_BATTLE_WINDOW(window), m1->hp);
				gm_battle_window_set_hp_two(GM_BATTLE_WINDOW(window), m2->hp);
				gm_battle_window_set_ap_one(GM_BATTLE_WINDOW(window), m1->ap);
				gm_battle_window_set_ap_two(GM_BATTLE_WINDOW(window), m2->ap);
				gm_battle_window_set_wait_one(GM_BATTLE_WINDOW(window), ba1->wait);
				gm_battle_window_set_wait_two(GM_BATTLE_WINDOW(window), ba2->wait);
				gm_battle_window_set_fear_one(GM_BATTLE_WINDOW(window), ba1->fear);
				gm_battle_window_set_fear_two(GM_BATTLE_WINDOW(window), ba2->fear);
				while (gtk_events_pending())
					gtk_main_iteration();
			}
		}
		if (retval == GM_LOST || retval == GM_WITHDRAWN) {
			if (retval != GM_WITHDRAWN) {
				guint a, nom = 0;
				if (gm_rand(50) > 35)
					gm_trainer_lower_skill(t1, m1->spec->type);
				if (gm_rand(50) > 15 && m1->obe > 0)
					m1->obe--;
				for (a = 0; a < t2->nom; a++)
					if (t2->monsters[a]->active == TRUE && used2[a] == TRUE)
						nom++;
				for (a = 0; a < t2->nom; a++) {
					if (t2->monsters[a]->active == TRUE && used2[a] == TRUE) {
						GMMonster *tmp = gm_monster_open(t2->monsters[a]->id);
						if (gm_rand(50) > 35)
							gm_trainer_raise_skill(t2, tmp->spec->type);
						if (gm_rand(50) > 15 && tmp->obe < 100)
							tmp->obe++;
						gm_monster_give_exp(tmp, (((((gm_monster_str(m1, 0) + gm_monster_def(m1, 0) + gm_monster_spd(m1, 0) + gm_monster_int(m1, 0)) / 3) * 2) / nom) * gm_trainer_skill(t2, tmp->spec->type)) / 20, viewable);
						if (t2->monsters[a]->id != m2->id)
							gm_monster_close(t2->monsters[a]->id);
					}
				}
			}
			gm_monster_close(m1->id);
			m1 = gm_trainer_select_monster(t1);
		}
		if (retval == GM_WON || retval == GM_ENEMY_WITHDREW) {
			if (retval != GM_ENEMY_WITHDREW) {
				guint a, nom = 0;
				if (gm_rand(50) > 35)
					gm_trainer_lower_skill(t2, m2->spec->type);
				if (gm_rand(50) > 15 && m2->obe > 0)
					m2->obe--;
				for (a = 0; a < t1->nom; a++)
					if (t1->monsters[a]->active == TRUE && used1[a] == TRUE)
						nom++;
				for (a = 0; a < t1->nom; a++) {
					if (t1->monsters[a]->active == TRUE && used1[a] == TRUE) {
						GMMonster *tmp = gm_monster_open(t1->monsters[a]->id);
						if (gm_rand(50) > 35)
							gm_trainer_raise_skill(t1, tmp->spec->type);
						if (gm_rand(50) > 15 && tmp->obe < 100)
							tmp->obe++;
						gm_monster_give_exp(tmp, (((((gm_monster_str(m2, 0) + gm_monster_def(m2, 0) + gm_monster_spd(m2, 0) + gm_monster_int(m2, 0)) / 3) * 2) / nom) * gm_trainer_skill(t1, tmp->spec->type)) / 20, viewable);
						if (t1->monsters[a]->id != m1->id)
							gm_monster_close(t1->monsters[a]->id);
					}
				}
			}
			gm_monster_close(m2->id);
			m2 = gm_trainer_select_monster(t2);
		}
		if (retval == GM_WITHDRAWN)
			withdraw1++;
		if (retval == GM_ENEMY_WITHDREW)
			withdraw2++;
		if (withdraw1 > 5 || m1 == 0)
			won = GM_TWO_WON;
		if (withdraw2 > 5 || retval == GM_CAPTURE || m2 == 0)
			won = GM_ONE_WON;
	}
	if (won == GM_ONE_WON) {
		gm_monster_close(m1->id);
		if (viewable == TRUE)
			gnome_dialog_run(GNOME_DIALOG(gnome_ok_dialog("You won.")));
	} else {
		gm_monster_close(m2->id);
		if (viewable == TRUE)
			gnome_dialog_run(GNOME_DIALOG(gnome_ok_dialog("You lost.")));
	}
	if (viewable == TRUE)
		gtk_widget_destroy(window);
	return retval;
}

gboolean
gm_battle_action(guint act, GMBattleEffects * one, GMBattleEffects * two, GMItemList * item)
{
	gchar *strng;
	strng = "\n";
	if (one->window != NULL)
		gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	if (one->poisoned == TRUE) {
		guint pdmg = ((gm_monster_maxhp(one->monster, 0) / 100) + 1) + (gm_rand((gm_monster_maxhp(one->monster, 0) / 50) + 1));
		strng = g_strdup_printf("%s was hurt by poison!\n", one->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		free(strng);
		if (one->monster->hp <= pdmg) {
			one->status = GM_FAINTED;
			one->monster->hp = 0;
			return FALSE;
		} else
			one->monster->hp -= pdmg;
	}
	if (one->status == GM_STUN && gm_rand(2) == 1) {
		if (gm_rand(2) == 1) {
			strng = g_strdup_printf("%s is stunned!\n", one->monster->name);
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
		} else {
			strng = g_strdup_printf("%s regained %s bearing, %s is no longer stunned!\n", one->monster->name, (one->monster->gen == GM_MALE ? "his" : "her"), (one->monster->gen == GM_MALE ? "he" : "she"));
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
			one->status = GM_NORMAL;
		}
		return FALSE;
	}
	if (one->status == GM_CONFUSED && gm_rand(2) == 1) {
		if (gm_rand(10) != 0) {
			guint pdmg = gm_monster_str(one->monster, 0) / 2;
			strng = g_strdup_printf("%s hurt %sself in %s confusion!\n", one->monster->name, (one->monster->gen == GM_MALE ? "him" : "her"), (one->monster->gen == GM_MALE ? "his" : "her"));
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
			if (one->window != NULL)
				gm_battle_effects_deal_damage(one, 0, pdmg, GM_PHYSICAL);
			return FALSE;
		} else {
			strng = g_strdup_printf("%s is no longer confused!\n", one->monster->name);
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
			one->status = GM_NORMAL;
		}
	}
	if (one->status == GM_SLEEP) {
		if (gm_rand(2) == 1) {
			strng = g_strdup_printf("%s is asleep!\n", one->monster->name);
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
		} else {
			strng = g_strdup_printf("%s woke up!\n", one->monster->name);
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
			one->status = GM_NORMAL;
		}
		return FALSE;
	}
	if (gm_rand(100) < one->fear && act != 0 && act != 5) {
		strng = g_strdup_printf("%s is too scared to attack!\n", one->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		free(strng);
		return FALSE;
	}
	if (gm_rand(one->monster->obe + gm_trainer_skill(one->trainer, one->monster->spec->type)) < 5 && one->monster->obe < 100 && gm_trainer_skill(one->trainer, one->monster->spec->type) < 100 && act != 0) {
		strng = g_strdup_printf("%s isn't listening!\n", one->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		free(strng);
		do {
			act = gm_rand(6 + one->monster->noa);
		}
		while (act != 1 && act != 3 && act < 6);
	}
	switch (act) {
	case 0:
		{
			GMItemList *item = gm_trainer_select_item(one->trainer);
			if (item != NULL) {
				gboolean worked = gm_item_battle_use(item->name, one, (one->window != NULL ? GM_BATTLE_WINDOW(one->window)->text : NULL));
				if (worked == TRUE)
					gm_trainer_remove_item(gm_trainer, item->name, 1);
				else {
					strng = g_strdup_printf("%s's trainer's use of %s failed.\n", one->monster->name, item->name);
					if (one->window != NULL)
						gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
					free(strng);
				}
			} else {
				strng = g_strdup_printf("%s's trainer choose to use an item but didn't.\n", one->monster->name);
				if (one->window != NULL)
					gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
				free(strng);
			}
		}
		break;
	case 1:
		strng = g_strdup_printf("%s is holding back...\n", one->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		free(strng);
		break;
	case 2:
		strng = "Hiding doesn't work yet, struggling instead...\n";
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
	case 3:
		strng = g_strdup_printf("%s is struggling!\n", one->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		free(strng);
		gm_battle_struggle(one, two);
		break;
	case 4:
		one->monster->ap -= 10;
		strng = g_strdup_printf("Trying to capture %s!\n", two->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		free(strng);
		if ((gm_rand((two->monster->hp * 100) / gm_monster_maxhp(two->monster, 0)) < 3) || two->status == GM_SLEEP || two->status == GM_STUN) {
			strng = g_strdup_printf("You captured %s!\n", two->monster->name);
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
			two->status = GM_FAINTED;
			return TRUE;
		} else {
			strng = g_strdup_printf("You failed to capture %s.\n", two->monster->name);
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
		}
		break;
	case 5:
		strng = g_strdup_printf("%s withdrew from battle!\n", one->monster->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		free(strng);
		one->status = GM_FAINTED;
		break;
	default:
		strng = g_strdup_printf("%s used %s!\n", one->monster->name, one->monster->abilities[act - 6]->name);
		if (one->window != NULL)
			gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
		free(strng);
		gm_ability_call(one->monster->abilities[act - 6]->name, one, two);
		break;
	}
	return FALSE;
}

void
gm_battle_eot(guint php, GMBattleEffects * one, GMBattleEffects * two)
{
	gchar *strng;
	switch (one->eot) {
	case GM_COUNTER_ATTACK:
		if (php - one->monster->hp > 0) {
			if (two->monster->hp < (php - one->monster->hp)) {
				two->status = GM_FAINTED;
				two->monster->hp = 0;
			} else
				two->monster->hp -= php - one->monster->hp;
			strng = g_strdup_printf("%s counter attacked!\n", one->monster->name);
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
		}
		break;
	case GM_ABSORB_AS_HP:
		if (php - one->monster->hp > 0) {
			if (one->monster->hp + (((php - one->monster->hp) * 3) / 2) >= one->monster->maxhp)
				one->monster->hp = one->monster->maxhp;
			else
				one->monster->hp += ((php - one->monster->hp) * 3) / 2;
			strng = g_strdup_printf("%s absorbed damage.\n", one->monster->name);
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
		}
		break;
	case GM_ABSORB_AS_STR:
		if ((php - one->monster->hp) / 2 > 0) {
			one->str += ((php - one->monster->hp) / 2);
			strng = g_strdup_printf("%s is getting mad, %s strength grew!\n", one->monster->name, (one->monster->gen == GM_MALE ? "his" : "her"));
			if (one->window != NULL)
				gm_battle_window_message(GM_BATTLE_WINDOW(one->window), strng);
			free(strng);
		}
		break;
	default:
		break;
	}
	one->eot = GM_EOT_NONE;
}

guint
gm_battle_player_cb(GMBattleEffects * mon, gboolean capture)
{
	GtkWidget *vbox = gtk_vbox_new(TRUE, 0);
	GtkWidget *button[11];
	guint action = 0, a, none = 0, num = 0;
	for (a = 0; a < 11; a++) {
		button[a] = gtk_button_new();
		gtk_widget_set_sensitive(button[a], FALSE);
		gtk_object_set_user_data(GTK_OBJECT(button[a]), &action);
	}
	for (a = 0; a < mon->monster->noa; a++) {
		if (mon->monster->abilities[a] != 0 && mon->monster->abilities[a]->active == TRUE) {
			GMAbility *abl = gm_ability_match(mon->monster->abilities[a]->name);
			gchar *name = g_strdup_printf("%s - %u", abl->name, abl->cost);
			gchar *filename = g_strdup_printf("gm-%s.xpm", gm_class_name(abl->type));
			gchar *tmp = gm_pixmap_file(filename);
			GtkWidget *bhbox = gtk_hbox_new(FALSE, 0);
			GtkWidget *pic = gnome_pixmap_new_from_file(tmp);
			gtk_box_pack_start(GTK_BOX(bhbox), pic, FALSE, TRUE, 0);
			gtk_box_pack_start(GTK_BOX(bhbox), gtk_label_new(name), TRUE, TRUE, 0);
			gtk_container_add(GTK_CONTAINER(button[num + 6]), bhbox);
			gtk_box_pack_start(GTK_BOX(vbox), button[num + 6], FALSE, TRUE, 0);
			if (abl->cost <= mon->monster->ap) {
				gtk_signal_connect(GTK_OBJECT(button[num + 6]), "clicked", GTK_SIGNAL_FUNC(&gm_battle_player_cb_click_cb), (void *)6 + a);
				gtk_widget_set_sensitive(button[num + 6], TRUE);
			} else
				none++;
			free(tmp);
			free(filename);
			free(name);
			num++;
		} else
			none++;
	}
	for (a = num; a < 5; a++) {
		gtk_container_add(GTK_CONTAINER(button[a + 6]), gtk_label_new(" -- -- -- "));
		gtk_widget_set_sensitive(button[a + 6], FALSE);
		gtk_box_pack_start(GTK_BOX(vbox), button[a + 6], FALSE, TRUE, 0);
	}
	{
		gchar *name = g_strdup_printf("%s - %u", "Item", 0);
		gtk_container_add(GTK_CONTAINER(button[0]), gtk_label_new(name));
		gtk_signal_connect(GTK_OBJECT(button[0]), "clicked", GTK_SIGNAL_FUNC(&gm_battle_player_cb_click_cb), (void *)0);
		gtk_widget_set_sensitive(button[0], TRUE);
		gtk_box_pack_start(GTK_BOX(vbox), button[0], FALSE, TRUE, 0);
		free(name);
	}
	{
		gchar *name = g_strdup_printf("%s - %u", "Wait", 0);
		gtk_container_add(GTK_CONTAINER(button[1]), gtk_label_new(name));
		gtk_signal_connect(GTK_OBJECT(button[1]), "clicked", GTK_SIGNAL_FUNC(&gm_battle_player_cb_click_cb), (void *)1);
		gtk_widget_set_sensitive(button[1], TRUE);
		gtk_box_pack_start(GTK_BOX(vbox), button[1], FALSE, TRUE, 0);
		free(name);
	}
	{
		gchar *name = g_strdup_printf("%s - %u", "Struggle", 0);
		gtk_container_add(GTK_CONTAINER(button[2]), gtk_label_new(name));
		if (none >= mon->monster->noa) {
			gtk_signal_connect(GTK_OBJECT(button[2]), "clicked", GTK_SIGNAL_FUNC(&gm_battle_player_cb_click_cb), (void *)2);
			gtk_widget_set_sensitive(button[2], TRUE);
		}
		gtk_box_pack_start(GTK_BOX(vbox), button[2], FALSE, TRUE, 0);
		free(name);
	}
	{
		gchar *name = g_strdup_printf("%s - %u", "Hide", 5);
		gtk_container_add(GTK_CONTAINER(button[3]), gtk_label_new(name));
		if (mon->monster->ap >= 5) {
			gtk_signal_connect(GTK_OBJECT(button[3]), "clicked", GTK_SIGNAL_FUNC(&gm_battle_player_cb_click_cb), (void *)3);
			gtk_widget_set_sensitive(button[3], FALSE);
		}
		gtk_box_pack_start(GTK_BOX(vbox), button[3], FALSE, TRUE, 0);
		free(name);
	}
	{
		gchar *name = g_strdup_printf("%s - %u", "Capture", 10);
		gtk_container_add(GTK_CONTAINER(button[4]), gtk_label_new(name));
		if (mon->monster->ap >= 10 && capture == TRUE) {
			gtk_signal_connect(GTK_OBJECT(button[4]), "clicked", GTK_SIGNAL_FUNC(&gm_battle_player_cb_click_cb), (void *)4);
			gtk_widget_set_sensitive(button[4], TRUE);
		}
		gtk_box_pack_start(GTK_BOX(vbox), button[4], FALSE, TRUE, 0);
		free(name);
	}
	{
		gchar *name = g_strdup_printf("%s - %u", "Withdraw", 0);
		gtk_container_add(GTK_CONTAINER(button[5]), gtk_label_new(name));
		gtk_signal_connect(GTK_OBJECT(button[5]), "clicked", GTK_SIGNAL_FUNC(&gm_battle_player_cb_click_cb), (void *)5);
		gtk_widget_set_sensitive(button[5], TRUE);
		gtk_box_pack_start(GTK_BOX(vbox), button[5], FALSE, TRUE, 0);
		free(name);
	}
	gtk_container_add(GTK_CONTAINER(GM_BATTLE_WINDOW(mon->window)->scroll), vbox);
	gtk_widget_show_all(vbox);
	while (action == 0)
		while (gtk_events_pending())
			gtk_main_iteration();
	gtk_widget_destroy(vbox);
	if (gm_net_opponent()) {
		guint atk = action - 1;
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing to opponent...\n", getpid(), __LINE__);
		write(gm_net_opponent(), &atk, sizeof(guint));
		gm_net_wait_write();
	}
	return action - 1;
}

void
gm_battle_player_cb_click_cb(GtkWidget * button, guint num)
{
	*((guint *) gtk_object_get_user_data(GTK_OBJECT(button))) = num + 1;
}

guint
gm_battle_ai_cb(GMBattleEffects * mon, gboolean capture)
{
	guint a, none = 0;
	for (a = 0; a < mon->monster->noa; a++)
		if (gm_ability_match(mon->monster->abilities[a]->name)->cost > mon->monster->ap || mon->monster->abilities[a]->active == FALSE)
			none++;
	if (none < mon->monster->noa) {
		guint numoftries = 0;
		while (numoftries < 50) {
			guint attack = rand() % mon->monster->noa;
			if (gm_ability_match(mon->monster->abilities[attack]->name)->cost <= mon->monster->ap && mon->monster->abilities[attack]->active == TRUE) {
				if (gm_net_opponent()) {
					guint atk = 6 + attack;
					fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing to opponent...\n", getpid(), __LINE__);
					write(gm_net_opponent(), &atk, sizeof(guint));
					gm_net_wait_write();
				}
				return 6 + attack;
			}
			numoftries++;
		}
	}
	if (gm_net_opponent()) {
		guint atk = 3;
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing to opponent...\n", getpid(), __LINE__);
		write(gm_net_opponent(), &atk, sizeof(guint));
		gm_net_wait_write();
	}
	return 3;
}

guint
gm_battle_net_cb(GMBattleEffects * mon, gboolean capture)
{
	guint rv = 0;
	if (gm_net_opponent()) {
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Reading from opponent...\n", getpid(), __LINE__);
		gm_net_wait();
		read(gm_net_opponent(), &rv, sizeof(guint));
	}
	return rv;
}
