#include "gm-battle-window.h"
#include "battle.h"
#include "filedirs.h"

#define SELF(x) GM_BATTLE_WINDOW(x)
#define SELF_CONST(x) GM_BATTLE_WINDOW_CONST(x)
#define IS_SELF(x) GM_IS_BATTLE_WINDOW(x)
#define SELF_CLASS(x) GM_BATTLE_WINDOW_CLASS(x)
#define SELF_GET_CLASS(x) GM_BATTLE_WINDOW_GET_CLASS(x)

typedef GMBattleWindow Self;
typedef GMBattleWindowClass SelfClass;

#ifndef GTK_CLASS_TYPE
#define GTK_CLASS_TYPE(x) (GTK_OBJECT_CLASS(x)->type)
#endif

static void gm_battle_window_init (GMBattleWindow * o) G_GNUC_UNUSED;
static void gm_battle_window_class_init (GMBattleWindowClass * c) G_GNUC_UNUSED;

static GtkWindowClass *parent_class = NULL;

GtkType
gm_battle_window_get_type (void)
{
	static GtkType type = 0;

	if (type == 0) {
		static const GtkTypeInfo info = {
			"GMBattleWindow",
			sizeof (GMBattleWindow),
			sizeof (GMBattleWindowClass),
			(GtkClassInitFunc) gm_battle_window_class_init,
			(GtkObjectInitFunc) gm_battle_window_init,
			NULL,
			NULL,
			(GtkClassInitFunc) NULL
		};

		type = gtk_type_unique (gtk_window_get_type(), &info);
	}

	return type;
}

#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define new() gm_battle_window_new()
#define message(args...) gm_battle_window_message(args)
#define set_hp_one(args...) gm_battle_window_set_hp_one(args)
#define set_hp_two(args...) gm_battle_window_set_hp_two(args)
#define set_ap_one(args...) gm_battle_window_set_ap_one(args)
#define set_ap_two(args...) gm_battle_window_set_ap_two(args)
#define set_wait_one(args...) gm_battle_window_set_wait_one(args)
#define set_wait_two(args...) gm_battle_window_set_wait_two(args)
#define set_fear_one(args...) gm_battle_window_set_fear_one(args)
#define set_fear_two(args...) gm_battle_window_set_fear_two(args)
#define change_monster_one(args...) gm_battle_window_change_monster_one(args)
#define change_monster_two(args...) gm_battle_window_change_monster_two(args)
#endif

static GtkWidget * (* const new) (void) = gm_battle_window_new;
static void (* const message) (GMBattleWindow * window, gchar * text) = gm_battle_window_message;
static void (* const set_hp_one) (GMBattleWindow * window, guint val) = gm_battle_window_set_hp_one;
static void (* const set_hp_two) (GMBattleWindow * window, guint val) = gm_battle_window_set_hp_two;
static void (* const set_ap_one) (GMBattleWindow * window, guint val) = gm_battle_window_set_ap_one;
static void (* const set_ap_two) (GMBattleWindow * window, guint val) = gm_battle_window_set_ap_two;
static void (* const set_wait_one) (GMBattleWindow * window, guint val) = gm_battle_window_set_wait_one;
static void (* const set_wait_two) (GMBattleWindow * window, guint val) = gm_battle_window_set_wait_two;
static void (* const set_fear_one) (GMBattleWindow * window, guint val) = gm_battle_window_set_fear_one;
static void (* const set_fear_two) (GMBattleWindow * window, guint val) = gm_battle_window_set_fear_two;
static void (* const change_monster_one) (GMBattleWindow * window, gpointer monp) = gm_battle_window_change_monster_one;
static void (* const change_monster_two) (GMBattleWindow * window, gpointer monp) = gm_battle_window_change_monster_two;

#define GET_NEW ((GMBattleWindow *)gtk_type_new(gm_battle_window_get_type()))

static void 
gm_battle_window_init (GMBattleWindow * o)
{
#define __GOB_FUNCTION__ "GM:Battle:Window::init"
	return;
	o = NULL;
}
#undef __GOB_FUNCTION__
static void 
gm_battle_window_class_init (GMBattleWindowClass * c)
{
#define __GOB_FUNCTION__ "GM:Battle:Window::class_init"

	parent_class = gtk_type_class (gtk_window_get_type ());

	return;
	c = NULL;
}
#undef __GOB_FUNCTION__



GtkWidget * 
gm_battle_window_new (void)
{
		GtkWidget *widg = gtk_type_new(gm_battle_window_get_type());
		          GM_BATTLE_WINDOW(widg)->vbox = gtk_vbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->frame1 = 0;
		          GM_BATTLE_WINDOW(widg)->frame2 = 0;
		          GM_BATTLE_WINDOW(widg)->f1vbox = gtk_vbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->f2vbox = gtk_vbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->h1hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->h2hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->h1label = gtk_label_new("HP: ");
		          GM_BATTLE_WINDOW(widg)->h2label = gtk_label_new("HP: ");
		          GM_BATTLE_WINDOW(widg)->health1 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->health2 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->a1hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->a2hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->a1label = gtk_label_new("AP: ");
		          GM_BATTLE_WINDOW(widg)->a2label = gtk_label_new("AP: ");
		          GM_BATTLE_WINDOW(widg)->ap1 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->ap2 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->w1hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->w2hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->w1label = gtk_label_new("Wait: ");
		          GM_BATTLE_WINDOW(widg)->w2label = gtk_label_new("Wait: ");
		          GM_BATTLE_WINDOW(widg)->wait1 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->wait2 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->f1hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->f2hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->f1label = gtk_label_new("Fear: ");
		          GM_BATTLE_WINDOW(widg)->f2label = gtk_label_new("Fear: ");
		          GM_BATTLE_WINDOW(widg)->fear1 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->fear2 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->text = gtk_text_new(0, 0);
		          GM_BATTLE_WINDOW(widg)->fhbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->hbox = gtk_hbox_new(FALSE, 0);
		          GM_BATTLE_WINDOW(widg)->canvas = gnome_canvas_new();
		          GM_BATTLE_WINDOW(widg)->scroll = gtk_viewport_new(0, 0);
		          GM_BATTLE_WINDOW(widg)->scroller = gtk_vscrollbar_new(gtk_viewport_get_vadjustment(GTK_VIEWPORT(GM_BATTLE_WINDOW(widg)->scroll)));
		          gtk_text_set_word_wrap(GTK_TEXT(GM_BATTLE_WINDOW(widg)->text), TRUE);
		          gtk_widget_set_usize(GM_BATTLE_WINDOW(widg)->canvas, 400, 250);
		          gtk_widget_set_usize(GM_BATTLE_WINDOW(widg)->text, 250, 175);
		          gtk_widget_set_usize(GM_BATTLE_WINDOW(widg)->scroll, 150, 175);
		          gnome_canvas_set_scroll_region(GNOME_CANVAS(GM_BATTLE_WINDOW(widg)->canvas), 0, 0, 400, 300);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->vbox), GM_BATTLE_WINDOW(widg)->canvas, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->hbox), GM_BATTLE_WINDOW(widg)->scroll, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->hbox), GM_BATTLE_WINDOW(widg)->scroller, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->hbox), GM_BATTLE_WINDOW(widg)->text, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->vbox), GM_BATTLE_WINDOW(widg)->fhbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->vbox), GM_BATTLE_WINDOW(widg)->hbox, FALSE, TRUE, 0);
		          gtk_container_add(GTK_CONTAINER(widg), GM_BATTLE_WINDOW(widg)->vbox);
		          GM_BATTLE_WINDOW(widg)->frame1 = gtk_frame_new(NULL);
		          GM_BATTLE_WINDOW(widg)->frame2 = gtk_frame_new(NULL);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->fhbox), GM_BATTLE_WINDOW(widg)->frame1, TRUE, TRUE, 0);
		          gtk_box_pack_end(GTK_BOX(GM_BATTLE_WINDOW(widg)->fhbox), GM_BATTLE_WINDOW(widg)->frame2, TRUE, TRUE, 0);
		          GM_BATTLE_WINDOW(widg)->health1 = gtk_progress_bar_new();
		          GM_BATTLE_WINDOW(widg)->health2 = gtk_progress_bar_new();
		          gtk_container_add(GTK_CONTAINER(GM_BATTLE_WINDOW(widg)->frame1), GM_BATTLE_WINDOW(widg)->f1vbox);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f1vbox), GM_BATTLE_WINDOW(widg)->h1hbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f1vbox), GM_BATTLE_WINDOW(widg)->a1hbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f1vbox), GM_BATTLE_WINDOW(widg)->w1hbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f1vbox), GM_BATTLE_WINDOW(widg)->f1hbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->h1hbox), GM_BATTLE_WINDOW(widg)->h1label, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->h1hbox), GM_BATTLE_WINDOW(widg)->health1, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->a1hbox), GM_BATTLE_WINDOW(widg)->a1label, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->a1hbox), GM_BATTLE_WINDOW(widg)->ap1, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->w1hbox), GM_BATTLE_WINDOW(widg)->w1label, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->w1hbox), GM_BATTLE_WINDOW(widg)->wait1, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f1hbox), GM_BATTLE_WINDOW(widg)->f1label, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f1hbox), GM_BATTLE_WINDOW(widg)->fear1, TRUE, TRUE, 0);
		          gtk_container_add(GTK_CONTAINER(GM_BATTLE_WINDOW(widg)->frame2), GM_BATTLE_WINDOW(widg)->f2vbox);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f2vbox), GM_BATTLE_WINDOW(widg)->h2hbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f2vbox), GM_BATTLE_WINDOW(widg)->a2hbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f2vbox), GM_BATTLE_WINDOW(widg)->w2hbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f2vbox), GM_BATTLE_WINDOW(widg)->f2hbox, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->h2hbox), GM_BATTLE_WINDOW(widg)->h2label, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->h2hbox), GM_BATTLE_WINDOW(widg)->health2, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->a2hbox), GM_BATTLE_WINDOW(widg)->a2label, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->a2hbox), GM_BATTLE_WINDOW(widg)->ap2, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->w2hbox), GM_BATTLE_WINDOW(widg)->w2label, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->w2hbox), GM_BATTLE_WINDOW(widg)->wait2, TRUE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f2hbox), GM_BATTLE_WINDOW(widg)->f2label, FALSE, TRUE, 0);
		          gtk_box_pack_start(GTK_BOX(GM_BATTLE_WINDOW(widg)->f2hbox), GM_BATTLE_WINDOW(widg)->fear2, TRUE, TRUE, 0);
		          gtk_progress_set_show_text(GTK_PROGRESS(GM_BATTLE_WINDOW(widg)->health1), TRUE);
		          gtk_progress_set_show_text(GTK_PROGRESS(GM_BATTLE_WINDOW(widg)->health2), TRUE);
		          gtk_progress_set_show_text(GTK_PROGRESS(GM_BATTLE_WINDOW(widg)->ap1), TRUE);
		          gtk_progress_set_show_text(GTK_PROGRESS(GM_BATTLE_WINDOW(widg)->ap2), TRUE);
		          gtk_progress_set_show_text(GTK_PROGRESS(GM_BATTLE_WINDOW(widg)->wait1), TRUE);
		          gtk_progress_set_show_text(GTK_PROGRESS(GM_BATTLE_WINDOW(widg)->wait2), TRUE);
		          gtk_progress_set_show_text(GTK_PROGRESS(GM_BATTLE_WINDOW(widg)->fear1), TRUE);
		          gtk_progress_set_show_text(GTK_PROGRESS(GM_BATTLE_WINDOW(widg)->fear2), TRUE);
		          gtk_widget_show_all(widg);
		          gtk_widget_hide(widg);
		          gnome_window_icon_set_from_file(GTK_WINDOW(widg), gm_pixmap_file("gnome-gmbattle.png"));
		          return widg;
	}

void 
gm_battle_window_message (GMBattleWindow * window, gchar * text)
{
		gtk_text_insert(GTK_TEXT(window->text), 0, 0, 0, text, strlen(text));
		while (gtk_events_pending())
			gtk_main_iteration();
	}

void 
gm_battle_window_set_hp_one (GMBattleWindow * window, guint val)
{
		guint a, ohp = gtk_progress_get_value(GTK_PROGRESS(window->health1));
		for   (a = ohp; a != val; (a > val ? a-- : a++)) {
			gtk_progress_set_value(GTK_PROGRESS(window->health1), a);
			while (gtk_events_pending())
				gtk_main_iteration();
		} gtk_progress_set_value(GTK_PROGRESS(window->health1), val);
		while (gtk_events_pending())
			     gtk_main_iteration();
	}

void 
gm_battle_window_set_hp_two (GMBattleWindow * window, guint val)
{
		guint a, ohp = gtk_progress_get_value(GTK_PROGRESS(window->health2));
		for   (a = ohp; a != val; (a > val ? a-- : a++)) {
			gtk_progress_set_value(GTK_PROGRESS(window->health2), a);
			while (gtk_events_pending())
				gtk_main_iteration();
		} gtk_progress_set_value(GTK_PROGRESS(window->health2), val);
		while (gtk_events_pending())
			gtk_main_iteration();
	}

void 
gm_battle_window_set_ap_one (GMBattleWindow * window, guint val)
{
		guint a, ohp = gtk_progress_get_value(GTK_PROGRESS(window->ap1));
		for   (a = ohp; a != val; (a > val ? a-- : a++)) {
			gtk_progress_set_value(GTK_PROGRESS(window->ap1), a);
			while (gtk_events_pending())
				gtk_main_iteration();
		} gtk_progress_set_value(GTK_PROGRESS(window->ap1), val);
		while (gtk_events_pending())
			gtk_main_iteration();
	}

void 
gm_battle_window_set_ap_two (GMBattleWindow * window, guint val)
{
		guint a, ohp = gtk_progress_get_value(GTK_PROGRESS(window->ap2));
		for   (a = ohp; a != val; (a > val ? a-- : a++)) {
			gtk_progress_set_value(GTK_PROGRESS(window->ap2), a);
			while (gtk_events_pending())
				gtk_main_iteration();
		} gtk_progress_set_value(GTK_PROGRESS(window->ap2), val);
		while (gtk_events_pending())
			gtk_main_iteration();
	}

void 
gm_battle_window_set_wait_one (GMBattleWindow * window, guint val)
{
		guint a, ohp = gtk_progress_get_value(GTK_PROGRESS(window->wait1));
		if    (val > 0) {
			for (a = ohp; a != val; (a > val ? a-- : a++)) {
				gtk_progress_set_value(GTK_PROGRESS(window->wait1), a);
				while (gtk_events_pending())
					gtk_main_iteration();
		}}
		gtk_progress_set_value(GTK_PROGRESS(window->wait1), val);
		while (gtk_events_pending())
			gtk_main_iteration();
	}

void 
gm_battle_window_set_wait_two (GMBattleWindow * window, guint val)
{
		guint a, ohp = gtk_progress_get_value(GTK_PROGRESS(window->wait2));
		if    (val > 0) {
			for (a = ohp; a != val; (a > val ? a-- : a++)) {
				gtk_progress_set_value(GTK_PROGRESS(window->wait2), a);
				while (gtk_events_pending())
					gtk_main_iteration();
		}}
		gtk_progress_set_value(GTK_PROGRESS(window->wait2), val);
		while (gtk_events_pending())
			gtk_main_iteration();
	}

void 
gm_battle_window_set_fear_one (GMBattleWindow * window, guint val)
{
		guint a, ohp = gtk_progress_get_value(GTK_PROGRESS(window->fear1));
		if    (val > 0) {
			for (a = ohp; a != val; (a > val ? a-- : a++)) {
				gtk_progress_set_value(GTK_PROGRESS(window->fear1), a);
				while (gtk_events_pending())
					gtk_main_iteration();
		}}
		gtk_progress_set_value(GTK_PROGRESS(window->fear1), val);
		while (gtk_events_pending())
			gtk_main_iteration();
	}

void 
gm_battle_window_set_fear_two (GMBattleWindow * window, guint val)
{
		guint a, ohp = gtk_progress_get_value(GTK_PROGRESS(window->fear2));
		if    (val > 0) {
			for (a = ohp; a != val; (a > val ? a-- : a++)) {
				gtk_progress_set_value(GTK_PROGRESS(window->fear2), a);
				while (gtk_events_pending())
					gtk_main_iteration();
		}}
		gtk_progress_set_value(GTK_PROGRESS(window->fear2), val);
		while (gtk_events_pending())
			gtk_main_iteration();
	}

void 
gm_battle_window_change_monster_one (GMBattleWindow * window, gpointer monp)
{
		GMBattleEffects *mon = (GMBattleEffects *) monp;
		gchar *strng;
		      gtk_progress_configure(GTK_PROGRESS(window->health1), mon->monster->hp, 0, gm_monster_maxhp(mon->monster, 0));
		      gtk_progress_configure(GTK_PROGRESS(window->ap1), mon->monster->ap, 0, 100);
		      gtk_progress_configure(GTK_PROGRESS(window->wait1), mon->wait, 0, 1000);
		      gtk_progress_configure(GTK_PROGRESS(window->fear1), mon->fear, 0, 100);
		      strng = g_strdup_printf("%s - Lvl %u", mon->monster->name, mon->monster->lvl);
		      gtk_frame_set_label(GTK_FRAME(window->frame1), strng);
		      free(strng);
		while (gtk_events_pending())
			      gtk_main_iteration();
	}

void 
gm_battle_window_change_monster_two (GMBattleWindow * window, gpointer monp)
{
		GMBattleEffects *mon = (GMBattleEffects *) monp;
		gchar *strng;
		      gtk_progress_configure(GTK_PROGRESS(window->health2), mon->monster->hp, 0, gm_monster_maxhp(mon->monster, 0));
		      gtk_progress_configure(GTK_PROGRESS(window->ap2), mon->monster->ap, 0, 100);
		      gtk_progress_configure(GTK_PROGRESS(window->wait2), mon->wait, 0, 1000);
		      gtk_progress_configure(GTK_PROGRESS(window->fear2), mon->fear, 0, 100);
		      strng = g_strdup_printf("%s - Lvl %u", mon->monster->name, mon->monster->lvl);
		      gtk_frame_set_label(GTK_FRAME(window->frame2), strng);
		      free(strng);
		while (gtk_events_pending())
			      gtk_main_iteration();
}

#if (!defined __GNUC__) || (defined __GNUC__ && defined __STRICT_ANSI__)
static void
___gm_battle_window_really_bad_hack_to_avoid_warnings(void)
{
	((void (*)(void))new)();
	((void (*)(void))message)();
	((void (*)(void))set_hp_one)();
	((void (*)(void))set_hp_two)();
	((void (*)(void))set_ap_one)();
	((void (*)(void))set_ap_two)();
	((void (*)(void))set_wait_one)();
	((void (*)(void))set_wait_two)();
	((void (*)(void))set_fear_one)();
	((void (*)(void))set_fear_two)();
	((void (*)(void))change_monster_one)();
	((void (*)(void))change_monster_two)();
	___gm_battle_window_really_bad_hack_to_avoid_warnings();
}
#endif
