
#include <math.h>
#include <gnome.h>
#include <libgnomeui/gnome-window-icon.h>
#include "filedirs.h"
#include "gmonsters.h"

static void gm_manager_select(GtkWidget *, guint, guint);
static void gm_manager_ability_select(GtkWidget *, guint, guint);
static void gm_manager_toggle_active();
static void gm_manager_toggle_ability_active();
static void gm_manager_toggle_rest_dialog();
static void gm_manager_rest();
static void gm_manager_use_item();
static void gm_manager_release();
static void gm_manager_really_release(gint, gpointer);
static void gm_manager_name_change();
static void gm_manager_species_list();
static void gm_manager_slist_select();
static void gm_manager_trainer_info();

static GMMonster *mon = NULL;
static guint selected = 0;
static guint aselected = 0;
static gchar *infostr = 0;
static GtkWidget *mlist;
static GtkWidget *name;
static GtkWidget *info;
static GtkWidget *health;
static GtkWidget *ap;
static GtkWidget *experience;
static GtkWidget *hplabel;
static GtkWidget *aplabel;
static GtkWidget *explabel;
static GtkWidget *restb;
static GtkWidget *releaseb;
static GtkWidget *itemb;
static GtkWidget *tamer;
static GtkWidget *window;
static GtkWidget *activetb;
static GtkWidget *alist;
static GtkWidget *aactivetb;
static GtkWidget *slist_name;
static GtkWidget *slist_desc;
static GtkWidget *slist_view;
static GtkWidget *slist_chbox;
static GtkWidget *picview;
static GtkWidget *pic = NULL;
static gboolean close_out = FALSE;
static void gm_close() { close_out = TRUE; }

void gmmanager_main() {
	gchar *titles[2] = { "Act.", "Monster" };
	gchar *atitles[3] = { "Act.", "Cost", "Ability" };
	GtkWidget *packer;
	GtkWidget *tinfo;
	GtkWidget *species;
	GtkWidget *close;
	GtkWidget *frame;
	GtkWidget *aframe;
	GtkWidget *fhbox;
	GtkWidget *fvbox;
	GtkWidget *avbox;
	GtkWidget *bhbox;
	GtkWidget *hbox;
	GtkWidget *resttb;
	GMMonsterList **mons;
	guint a;
//	gnome_init("Gmonsters", "0.0.1", argc, argv);
//	gm_init();
	close_out = FALSE;
	window = gnome_app_new("Gmonsters", "GMonsters: Manager");
	gnome_window_icon_set_default_from_file(gm_pixmap_file("gnome-gmmanager.png"));
	gnome_window_icon_set_from_default(GTK_WINDOW(window));
	packer = gtk_packer_new();
	hbox = gtk_hbox_new(0, 0);
	close = gnome_stock_button(GNOME_STOCK_BUTTON_CLOSE);
	species = gtk_button_new_with_label("Species");
	tinfo = gtk_button_new_with_label("Trainer Info");
	activetb = gtk_toggle_button_new_with_label("Active");
	restb = gtk_button_new_with_label("Rest");
	releaseb = gtk_button_new_with_label("Release");
	itemb = gtk_button_new_with_label("Item");
	gtk_widget_set_sensitive(activetb, FALSE);
	gtk_widget_set_sensitive(restb, FALSE);
	gtk_widget_set_sensitive(releaseb, FALSE);
	resttb = gtk_toggle_button_new_with_label("Show \"Rested\" dialog");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(resttb), gnome_config_get_bool("/GMonsters/Manager/ShowRestDialog=true"));
	mlist = gtk_clist_new_with_titles(2, titles);
	gtk_widget_set_usize(mlist, 150, 1);
	for (a = 0; a < gm_trainer->nom; a++) {
		gchar *name[2] = { (gm_trainer->monsters[a]->active == TRUE ? "Yes" : "No"),
			gm_trainer->monsters[a]->name
		};
		guint b;
		b = gtk_clist_append(GTK_CLIST(mlist), name);
		gtk_clist_set_row_data(GTK_CLIST(mlist), b, gm_trainer->monsters[a]);
	}
	gtk_clist_set_reorderable(GTK_CLIST(mlist), TRUE);
	frame = gtk_frame_new("Statistics");
	fhbox = gtk_hbox_new(0, 0);
	fvbox = gtk_vbox_new(0, 0);
	bhbox = gtk_hbox_new(0, 0);
	name = gtk_entry_new();
	tamer = gtk_label_new("N/A");
	gtk_widget_set_sensitive(name, FALSE);
	hplabel = gtk_label_new("Health:");
	health = gtk_progress_bar_new();
	gtk_progress_set_show_text(GTK_PROGRESS(health), TRUE);
	aplabel = gtk_label_new("Action Points:");
	ap = gtk_progress_bar_new();
	gtk_progress_set_show_text(GTK_PROGRESS(ap), TRUE);
	info = gtk_label_new("Species:\nGender:\nLevel:\nStrength:\nDefense:\nSpeed:\nIntelligence:\nObedience:");
	gtk_label_set_justify(GTK_LABEL(info), GTK_JUSTIFY_LEFT);
	explabel = gtk_label_new("Experience:");
	experience = gtk_progress_bar_new();
	aframe = gtk_frame_new("Abilities");
	avbox = gtk_vbox_new(FALSE, 0);
	alist = gtk_clist_new_with_titles(3, atitles);
	aactivetb = gtk_toggle_button_new_with_label("Active");
	picview = gtk_viewport_new(0, 0);
	gtk_widget_set_usize(picview, 65, 65);
	gtk_widget_set_usize(alist, 150, 1);
	gtk_progress_set_show_text(GTK_PROGRESS(experience), TRUE);
	gtk_progress_configure(GTK_PROGRESS(health), 0, 0, 0);
	gtk_progress_configure(GTK_PROGRESS(ap), 0, 0, 0);
	gtk_progress_configure(GTK_PROGRESS(experience), 0, 0, 0);
	gtk_container_add(GTK_CONTAINER(frame), fhbox);
	gtk_box_pack_start(GTK_BOX(hbox), close, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), species, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), tinfo, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), itemb, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), resttb, TRUE, FALSE, 0);
	gtk_packer_add(GTK_PACKER(packer), hbox, GTK_SIDE_BOTTOM, GTK_ANCHOR_CENTER, 0, 0, 0, 0, 0, 0);
	gtk_packer_add(GTK_PACKER(packer), mlist, GTK_SIDE_LEFT, GTK_ANCHOR_NORTH, GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND, 0, 0, 0, 0, 0);
	gtk_packer_add(GTK_PACKER(packer), frame, GTK_SIDE_RIGHT, GTK_ANCHOR_NORTH, GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND, 0, 0, 0, 0, 0);
	gtk_box_pack_start(GTK_BOX(fhbox), fvbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fhbox), avbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(avbox), alist, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(avbox), aactivetb, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), picview, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), tamer, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), name, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), hplabel, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), health, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), aplabel, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), ap, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), info, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), explabel, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), experience, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(bhbox), activetb, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(bhbox), restb, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(bhbox), releaseb, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), bhbox, TRUE, TRUE, 0);
	gnome_app_set_contents(GNOME_APP(window), packer);
	gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(&gm_close), NULL);
	gtk_signal_connect(GTK_OBJECT(resttb), "clicked", GTK_SIGNAL_FUNC(&gm_manager_toggle_rest_dialog), NULL);
	gtk_signal_connect(GTK_OBJECT(activetb), "clicked", GTK_SIGNAL_FUNC(&gm_manager_toggle_active), NULL);
	gtk_signal_connect(GTK_OBJECT(restb), "clicked", GTK_SIGNAL_FUNC(&gm_manager_rest), NULL);
	gtk_signal_connect(GTK_OBJECT(releaseb), "clicked", GTK_SIGNAL_FUNC(&gm_manager_release), NULL);
	gtk_signal_connect(GTK_OBJECT(itemb), "clicked", GTK_SIGNAL_FUNC(&gm_manager_use_item), NULL);
	gtk_signal_connect(GTK_OBJECT(tinfo), "clicked", GTK_SIGNAL_FUNC(&gm_manager_trainer_info), NULL);
	gtk_signal_connect(GTK_OBJECT(species), "clicked", GTK_SIGNAL_FUNC(&gm_manager_species_list), NULL);
	gtk_signal_connect(GTK_OBJECT(close), "clicked", GTK_SIGNAL_FUNC(&gm_close), NULL);
	gtk_signal_connect(GTK_OBJECT(mlist), "select_row", GTK_SIGNAL_FUNC(&gm_manager_select), NULL);
	gtk_signal_connect(GTK_OBJECT(alist), "select_row", GTK_SIGNAL_FUNC(&gm_manager_ability_select), NULL);
	gtk_signal_connect(GTK_OBJECT(name), "activate", GTK_SIGNAL_FUNC(&gm_manager_name_change), NULL);
	gtk_signal_connect(GTK_OBJECT(aactivetb), "clicked", GTK_SIGNAL_FUNC(&gm_manager_toggle_ability_active), NULL);
	gtk_widget_show_all(window);
	while(close_out == FALSE)
		while(gtk_events_pending())
			gtk_main_iteration();
	mons = gm_trainer->monsters;
	gm_trainer->nom = GTK_CLIST(mlist)->rows;
	gm_trainer->monsters = malloc(sizeof(GMMonsterList *) * gm_trainer->nom);
	for (a = 0; a < gm_trainer->nom; a++)
		gm_trainer->monsters[a] = gtk_clist_get_row_data(GTK_CLIST(mlist), a);
	gtk_widget_destroy(window);
	gnome_config_sync();
	return 0;
}

static void
gm_manager_select(GtkWidget * widg, guint row, guint column)
{
	GMMonsterList *monl = (GMMonsterList *) gtk_clist_get_row_data(GTK_CLIST(mlist), row);
	guint a, num = 0;
	gm_monster_close(((GMMonsterList *)
					  gtk_clist_get_row_data(GTK_CLIST(mlist), selected))->id);
	selected = row;
	mon = gm_monster_open(monl->id);
	gtk_entry_set_text(GTK_ENTRY(name), mon->name);
	infostr = g_strdup_printf("Tamer: %s", mon->tamer);
	gtk_label_set_text(GTK_LABEL(tamer), infostr);
	free(infostr);
	infostr = g_strdup_printf("Species: %s\nGender: %s\nLevel: %u\nStrength: %u\nDefense: %u\nSpeed: %u\nIntelligence: %u\nObedience: %u", mon->spec->name, (mon->gen == GM_MALE ? "Male" : "Female"), mon->lvl, gm_monster_str(mon, 0), gm_monster_def(mon, 0), gm_monster_spd(mon, 0), gm_monster_int(mon, 0), mon->obe);
	gtk_label_set_text(GTK_LABEL(info), infostr);
	free(infostr);
	infostr = g_strdup_printf("Health: %u/%u", mon->hp, gm_monster_maxhp(mon, 0));
	gtk_label_set_text(GTK_LABEL(hplabel), infostr);
	free(infostr);
	infostr = g_strdup_printf("Experience: %u/%u", mon->exp, mon->nxp);
	gtk_label_set_text(GTK_LABEL(explabel), infostr);
	free(infostr);
	gtk_progress_configure(GTK_PROGRESS(health), mon->hp, 0, gm_monster_maxhp(mon, 0));
	gtk_progress_configure(GTK_PROGRESS(ap), mon->ap, 0, 100);
	gtk_progress_configure(GTK_PROGRESS(experience), mon->exp, 0, mon->nxp);
	gtk_signal_disconnect_by_func(GTK_OBJECT(activetb), GTK_SIGNAL_FUNC(&gm_manager_toggle_active), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(activetb), monl->active);
	gtk_widget_set_sensitive(name, TRUE);
	for (a = 0; a < GTK_CLIST(mlist)->rows; a++)
		if (((GMMonsterList *)
			 gtk_clist_get_row_data(GTK_CLIST(mlist), a))->active == TRUE)
			num++;
	if ((num < 2 && monl->active == TRUE)
		|| (num > 4 && monl->active == FALSE) || mon->hp == 0)
		gtk_widget_set_sensitive(activetb, FALSE);
	else
		gtk_widget_set_sensitive(activetb, TRUE);
	gtk_widget_set_sensitive(restb, TRUE);
	gtk_widget_set_sensitive(releaseb, TRUE);
	gtk_clist_clear(GTK_CLIST(alist));
	for (a = 0; a < mon->noa; a++) {
		gchar *name[3] = { (mon->abilities[a]->active == TRUE ? "Yes" : "No"),
			g_strdup_printf("%u",
							gm_ability_match(mon->abilities[a]->name)->cost),
			mon->abilities[a]->name
		};
		guint b;
		b = gtk_clist_append(GTK_CLIST(alist), name);
		gtk_clist_set_row_data(GTK_CLIST(alist), b, mon->abilities[a]);
		free(name[1]);
	}
	gm_manager_ability_select(alist, 0, 0);
	gtk_signal_connect(GTK_OBJECT(activetb), "clicked", GTK_SIGNAL_FUNC(&gm_manager_toggle_active), NULL);
	if (pic != NULL) {
		if(GTK_IS_WIDGET(pic) == TRUE)
			gtk_widget_destroy(pic);
		pic = NULL;
	}
	if (mon->spec->image != NULL) {
		pic = gnome_pixmap_new_from_imlib_at_size(mon->spec->image, 60, 60);
		gtk_widget_show(pic);
		gtk_container_add(GTK_CONTAINER(picview), pic);
	}
}

static void
gm_manager_ability_select(GtkWidget * widg, guint row, guint column)
{
	GMMonAbl *abl = (GMMonAbl *) gtk_clist_get_row_data(GTK_CLIST(alist), row);
	guint a, num = 0;
	aselected = row;
	gtk_signal_disconnect_by_func(GTK_OBJECT(aactivetb), GTK_SIGNAL_FUNC(&gm_manager_toggle_ability_active), NULL);
	for (a = 0; a < GTK_CLIST(alist)->rows; a++)
		if (((GMMonAbl *) gtk_clist_get_row_data(GTK_CLIST(alist), a))->active == TRUE)
			num++;
	if ((num < 2 && abl->active == TRUE) || (num > 4 && abl->active == FALSE))
		gtk_widget_set_sensitive(aactivetb, FALSE);
	else
		gtk_widget_set_sensitive(aactivetb, TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(aactivetb), abl->active);
	gtk_signal_connect(GTK_OBJECT(aactivetb), "clicked", GTK_SIGNAL_FUNC(&gm_manager_toggle_ability_active), NULL);
}

static void
gm_manager_rest()
{
	mon->hp = gm_monster_maxhp(mon, 0);
	mon->ap = 100;
	gm_manager_select(mlist, selected, 0);
	if(gnome_config_get_bool("/GMonsters/Manager/ShowRestDialog=true") == TRUE)
		gnome_dialog_run(GNOME_DIALOG(gnome_ok_dialog("Rested and recovered Health and Action Points.")));
}

static void
gm_manager_use_item()
{
	GMItemList *item = gm_trainer_select_item(gm_trainer);
	if (item != NULL) {
		gboolean worked = gm_item_normal_use(item->name, gm_trainer);
		if (worked == TRUE)
			gm_trainer_remove_item(gm_trainer, item->name, 1);
	}
	gm_manager_select(mlist, selected, 0);
}

static void
gm_manager_toggle_active()
{
	GMMonsterList *monl = (GMMonsterList *) gtk_clist_get_row_data(GTK_CLIST(mlist),
																   selected);
	if (monl->active == TRUE)
		monl->active = FALSE;
	else
		monl->active = TRUE;
	gtk_clist_set_text(GTK_CLIST(mlist), selected, 0, (monl->active == TRUE ? "Yes" : "No"));
}

static void
gm_manager_toggle_rest_dialog()
{
	if (gnome_config_get_bool("/GMonsters/Manager/ShowRestDialog=true") == TRUE)
		gnome_config_set_bool("/GMonsters/Manager/ShowRestDialog", FALSE);
	else
		gnome_config_set_bool("/GMonsters/Manager/ShowRestDialog", TRUE);
}

static void
gm_manager_toggle_ability_active()
{
	GMMonAbl *abl = (GMMonAbl *) gtk_clist_get_row_data(GTK_CLIST(alist), aselected);
	if (abl->active == TRUE)
		abl->active = FALSE;
	else
		abl->active = TRUE;
	gtk_clist_set_text(GTK_CLIST(alist), aselected, 0, (abl->active == TRUE ? "Yes" : "No"));
}

static void
gm_manager_release()
{
	gchar *strng = g_strdup_printf("Once you release a monster, it is gone forever.\nAre you sure you want to release %s?",
								   mon->name);
	gboolean release = FALSE;
	if (GTK_CLIST(mlist)->rows == 1) {
		gnome_dialog_run(GNOME_DIALOG(gnome_app_message(GNOME_APP(window), "You can't release your last monster!")));
		free(strng);
		return;
	}
	gnome_dialog_run(GNOME_DIALOG(gnome_app_question_modal(GNOME_APP(window), strng, &gm_manager_really_release, &release)));
	if (release == TRUE) {
		gtk_clist_remove(GTK_CLIST(mlist), selected);
		selected = 0;
		gtk_entry_set_text(GTK_ENTRY(name), "");
		gtk_label_set_text(GTK_LABEL(info), "Species:\nGender:\nLevel:\nStrength:\nDefense:\nSpeed:\nIntelligence:\nObedience");
		gtk_label_set_text(GTK_LABEL(hplabel), "Health:");
		gtk_label_set_text(GTK_LABEL(explabel), "Experience:");
		gtk_progress_configure(GTK_PROGRESS(health), 0, 0, 0);
		gtk_progress_configure(GTK_PROGRESS(ap), 0, 0, 0);
		gtk_progress_configure(GTK_PROGRESS(experience), 0, 0, 0);
		gtk_widget_set_sensitive(name, FALSE);
		gtk_widget_set_sensitive(activetb, FALSE);
		gtk_widget_set_sensitive(restb, FALSE);
		gtk_widget_set_sensitive(releaseb, FALSE);
		gtk_clist_clear(GTK_CLIST(alist));
		gtk_widget_set_sensitive(aactivetb, FALSE);
		gm_monster_destroy(mon->id);
		mon = NULL;
	}
	free(strng);
}

static void
gm_manager_really_release(gint reply, gpointer data)
{
	gboolean *release = (gboolean *) data;
	if (reply == GNOME_YES)
		*release = TRUE;
}

static void
gm_manager_name_change()
{
	free(mon->name);
	mon->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(name)));
	free(((GMMonsterList *) gtk_clist_get_row_data(GTK_CLIST(mlist), selected))->name);
	((GMMonsterList *) gtk_clist_get_row_data(GTK_CLIST(mlist), selected))->name = strdup(gtk_entry_get_text(GTK_ENTRY(name)));
	gtk_clist_set_text(GTK_CLIST(mlist), selected, 1, mon->name);
	gm_manager_select(mlist, selected, 0);
}

static void
gm_manager_species_list()
{
	GtkWidget *dialog = gnome_dialog_new("GMonsters: Species List", GNOME_STOCK_BUTTON_CLOSE,
										 NULL);
	GtkWidget *slist = gtk_clist_new(1);
	GtkWidget *frame = gtk_frame_new("Species Stats");
	GtkWidget *vbox = gtk_vbox_new(0, 0);
	GtkWidget *hbox = gtk_hbox_new(0, 0);
	GtkWidget *dhbox = gtk_hbox_new(0, 0);
	GtkWidget *fvscroll = gtk_vscrollbar_new(NULL);
	GtkWidget *vscroll = gtk_vscrollbar_new(NULL);
	GtkWidget *viewport = gtk_viewport_new(0,
										   GTK_ADJUSTMENT(GTK_RANGE(vscroll)->adjustment));
	guint a;
	slist_view = gtk_viewport_new(0, 0);
	slist_chbox = gtk_hbox_new(0, 0);
	slist_name = gtk_label_new("None");
	slist_desc = gtk_text_new(0, GTK_ADJUSTMENT(GTK_RANGE(fvscroll)->adjustment));
	gtk_text_set_word_wrap(GTK_TEXT(slist_desc), TRUE);
	gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
	gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(window));
	gtk_container_add(GTK_CONTAINER(viewport), slist);
	gtk_container_add(GTK_CONTAINER(frame), vbox);
	gtk_container_add(GTK_CONTAINER(slist_view), slist_chbox);
	gtk_box_pack_start(GTK_BOX(vbox), slist_name, FALSE, TRUE, 0);
	gtk_widget_set_usize(slist_view, 150, 25);
	gtk_box_pack_start(GTK_BOX(vbox), slist_view, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), dhbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(dhbox), slist_desc, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(dhbox), fvscroll, FALSE, TRUE, 0);
	gtk_widget_set_usize(viewport, 150, 150);
	gtk_box_pack_start(GTK_BOX(hbox), viewport, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), vscroll, FALSE, TRUE, 0);
	gtk_widget_set_usize(frame, 200, 150);
	gtk_box_pack_start(GTK_BOX(hbox), frame, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), hbox, TRUE, TRUE, 0);
	for (a = 0; a < gm_species_list_length(); a++) {
		gchar *strng = g_strdup_printf("/GMonsters/Species Seen/%s=false",
									   (gm_species_get_list() + a)->name);
		if (gnome_config_get_bool(strng) == TRUE) {
			gchar *name[1] = { (gm_species_get_list() + a)->name };
			guint b;
			b = gtk_clist_append(GTK_CLIST(slist), name);
			gtk_clist_set_row_data(GTK_CLIST(slist), b, (void *)(gm_species_get_list() + a));
		}
		free(strng);
	}
	gtk_signal_connect(GTK_OBJECT(slist), "select_row", GTK_SIGNAL_FUNC(&gm_manager_slist_select), NULL);
	gtk_widget_show_all(dialog);
	gnome_dialog_run(GNOME_DIALOG(dialog));
}

static void
gm_manager_slist_select(GtkWidget * slist, guint row, guint column)
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), row);
	guint a;
	gtk_text_backward_delete(GTK_TEXT(slist_desc), gtk_text_get_length(GTK_TEXT(slist_desc)));
	gtk_label_set_text(GTK_LABEL(slist_name), spec->name);
	gtk_text_insert(GTK_TEXT(slist_desc), 0, 0, 0, spec->desc, strlen(spec->desc));
	gtk_widget_destroy(slist_chbox);
	slist_chbox = gtk_hbox_new(0, 0);
	gtk_container_add(GTK_CONTAINER(slist_view), slist_chbox);
	for (a = 0; a < 16; a++) {
		GMClassification klass = pow(2, a);
		if (spec->type & klass) {
			gchar *filename = g_strdup_printf("gm-%s.xpm", gm_class_name(klass));
			gchar *tmp = gm_pixmap_file(filename);
			GtkWidget *pic = gnome_pixmap_new_from_file(tmp);
			gtk_box_pack_start(GTK_BOX(slist_chbox), pic, TRUE, TRUE, 0);
			free(tmp);
			free(filename);
		}
	}
	if (spec->type == 0) {
		gchar *tmp = gm_pixmap_file("gm-normal.xpm");
		GtkWidget *pic = gnome_pixmap_new_from_file(tmp);
		gtk_box_pack_start(GTK_BOX(slist_chbox), pic, TRUE, TRUE, 0);
		free(tmp);
	}
	gtk_widget_show_all(slist_view);
}

static void
gm_manager_trainer_info()
{
	GtkWidget *dialog = gnome_dialog_new("GMonsters: Trainer Info", GNOME_STOCK_BUTTON_OK,
										 NULL);
	gchar *info = g_strdup_printf("Name: %s\nSkill Levels:\nNormal: %u\nStone: %u\nFlying: %u\nElectric: %u\nWater: %u\nFire: %u\nPoison: %u\nInsect: %u\nPlant: %u\nFighting: %u\nPsychic: %u\nFungus: %u\nNocturnal: %u\nCybernetic: %u\nIce: %u\nEnergy: %u\nGhost: %u",
								  gm_trainer->name,
								  gm_trainer->skill.normal,
								  gm_trainer->skill.stone,
								  gm_trainer->skill.flying,
								  gm_trainer->skill.electric,
								  gm_trainer->skill.water,
								  gm_trainer->skill.fire,
								  gm_trainer->skill.poison,
								  gm_trainer->skill.insect,
								  gm_trainer->skill.plant,
								  gm_trainer->skill.fighting,
								  gm_trainer->skill.psychic,
								  gm_trainer->skill.fungus,
								  gm_trainer->skill.nocturnal,
								  gm_trainer->skill.cybernetic,
								  gm_trainer->skill.ice,
								  gm_trainer->skill.energy,
								  gm_trainer->skill.ghost);
	GtkWidget *label = gtk_label_new(info);
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
	gtk_widget_show_all(dialog);
	gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
	gnome_dialog_run(GNOME_DIALOG(dialog));
	free(info);
}
