
#include <gnome.h>
#include <libgnomeui/gnome-window-icon.h>
#include "gmonsters.h"
#include "filedirs.h"

static GtkWidget *playername;
static GtkWidget *monstername;
static GtkWidget *monsterspecies;
static GtkWidget *mongenbm;
static GtkWidget *mongenbf;
static guint selected = 0;
static gboolean close_out = FALSE;
static void gm_close() { close_out = TRUE; }

static void
gm_select_row(GtkCList * list, guint row, guint column)
{
	selected = row;
}

static void
gm_finish()
{
	gchar *strng;
	GMMonster *mon;
	GnomeDialog *dia;
	mon = gm_monster_new((GMSpecies *)
						 gtk_clist_get_row_data(GTK_CLIST(monsterspecies), selected), gtk_entry_get_text(GTK_ENTRY(monstername)), (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(mongenbm)) == TRUE ? GM_MALE : GM_FEMALE), 10);
	gm_trainer = gm_trainer_new();
	gm_trainer->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(playername)));
	gm_trainer_add_monster(gm_trainer, mon);
	gm_trainer->monsters[0]->active = TRUE;
	gm_monster_close(mon->id);
	strng = g_strdup_printf("Name: %s\nSpecies: %s\nGender: %s\nLevel: %u\nExperience: %u/%u\nHealth: %u/%u\nStrength: %u\nDefense: %u\nSpeed: %u\nIntelligence: %u", mon->name, mon->spec->name, (mon->gen == GM_MALE ? "Male" : "Female"), mon->lvl, mon->exp, mon->nxp, mon->hp, gm_monster_maxhp(mon, 0), gm_monster_str(mon, 0), gm_monster_def(mon, 0), gm_monster_spd(mon, 0), gm_monster_int(mon, 0));
	dia = GNOME_DIALOG(gnome_ok_dialog(strng));
	free(strng);
	gtk_widget_show_all(GTK_WIDGET(dia));
	gnome_dialog_run(dia);
	gnome_config_clean_section("/GMonsters/Species Seen");
	strng = g_strdup_printf("/GMonsters/Species Seen/%s", mon->spec->name);
	gnome_config_set_bool(strng, TRUE);
	gm_trainer_add_item(gm_trainer, gm_item_match("Potion"), 5);
	free(strng);
	gm_close();
}

void gmnewuser_main() {
	gchar *titles[1] = { "Species" };
	GtkWidget *window;
	GtkWidget *druid;
	GtkWidget *startpage;
	GtkWidget *playerpage;
	GtkWidget *fmpage;
	GtkWidget *finishpage;
	GtkWidget *pnpack;
	GtkWidget *pnamelabel;
	GtkWidget *mnpack;
	GtkWidget *mnamelabel;
	GtkWidget *mgpack;
	GtkWidget *msview;
	GtkWidget *msscroll;
	GtkWidget *mshbox;
	GtkAdjustment *msadj;
	guint a = 0, b = 0;
//	gnome_init("Gmonsters", "0.0.1", argc, argv);
//	if (!access(gnome_util_home_file("gmtrainer"), F_OK))
//		remove(gnome_util_home_file("gmtrainer"));
//	gm_init();
	close_out = FALSE;
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), "Gmonsters: New User");
	gtk_widget_set_usize(window, 400, 400);
	gnome_window_icon_set_default_from_file(gm_pixmap_file("gnome-gmonsters.png"));
	druid = gnome_druid_new();
	startpage = gnome_druid_page_start_new_with_vals("New Player Setup", "Welcome to Gmonsters player setup!\nUse this to create a new profile.", 0, 0);
	gtk_signal_connect(GTK_OBJECT(startpage), "cancel", GTK_SIGNAL_FUNC(&gm_close), NULL);
	gnome_druid_append_page(GNOME_DRUID(druid), GNOME_DRUID_PAGE(startpage));
	playerpage = gnome_druid_page_standard_new_with_vals("Setup Gmonsters player", 0);
	pnamelabel = gtk_label_new("Nickname: ");
	playername = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(playername), getenv("USER"));
	pnpack = gtk_packer_new();
	gtk_packer_add(GTK_PACKER(pnpack), pnamelabel, GTK_SIDE_LEFT, GTK_ANCHOR_CENTER, (GtkPackerOptions) 0, 0, 0, 0, 0, 0);
	gtk_packer_add(GTK_PACKER(pnpack), playername, GTK_SIDE_LEFT, GTK_ANCHOR_CENTER, (GtkPackerOptions) (GTK_FILL_X | GTK_EXPAND), 0, 0, 0, 0, 0);
	gtk_box_pack_start(GTK_BOX(GNOME_DRUID_PAGE_STANDARD(playerpage)->vbox), pnpack, 0, 0, 0);
	gtk_signal_connect(GTK_OBJECT(playerpage), "cancel", GTK_SIGNAL_FUNC(&gm_close), NULL);
	gnome_druid_append_page(GNOME_DRUID(druid), GNOME_DRUID_PAGE(playerpage));
	fmpage = gnome_druid_page_standard_new_with_vals("Setup Initial Monster", 0);
	mnamelabel = gtk_label_new("Name: ");
	monstername = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(monstername), "Monster");
	mnpack = gtk_packer_new();
	gtk_packer_add(GTK_PACKER(mnpack), mnamelabel, GTK_SIDE_LEFT, GTK_ANCHOR_CENTER, (GtkPackerOptions) 0, 0, 0, 0, 0, 0);
	gtk_packer_add(GTK_PACKER(mnpack), monstername, GTK_SIDE_LEFT, GTK_ANCHOR_CENTER, (GtkPackerOptions) (GTK_FILL_X | GTK_EXPAND), 0, 0, 0, 0, 0);
	gtk_box_pack_start(GTK_BOX(GNOME_DRUID_PAGE_STANDARD(fmpage)->vbox), mnpack, 0, 0, 0);
	monsterspecies = gtk_clist_new_with_titles(1, titles);
	for (a = 0; a < gm_species_list_length(); a++) {
		char *tmp[1] = { gm_species_get_list()[a].name };
		b = gtk_clist_append(GTK_CLIST(monsterspecies), tmp);
		gtk_clist_set_row_data(GTK_CLIST(monsterspecies), b, (void *)(gm_species_get_list() + a));
	}
	gtk_signal_connect(GTK_OBJECT(monsterspecies), "select_row", GTK_SIGNAL_FUNC(&gm_select_row), NULL);
	msview = gtk_viewport_new(0, 0);
	gtk_container_add(GTK_CONTAINER(msview), monsterspecies);
	mshbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mshbox), msview, TRUE, TRUE, 0);
	msscroll = gtk_vscrollbar_new(gtk_viewport_get_vadjustment(GTK_VIEWPORT(msview)));
	gtk_box_pack_start(GTK_BOX(mshbox), msscroll, 0, 0, 0);
	gtk_box_pack_start(GTK_BOX(GNOME_DRUID_PAGE_STANDARD(fmpage)->vbox), mshbox, TRUE, TRUE, 0);
	mongenbm = gtk_radio_button_new_with_label(NULL, "Male");
	mongenbf = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(mongenbm)), "Female");
	mgpack = gtk_packer_new();
	gtk_packer_add(GTK_PACKER(mgpack), mongenbm, GTK_SIDE_LEFT, GTK_ANCHOR_CENTER, (GtkPackerOptions) 0, 0, 0, 0, 0, 0);
	gtk_packer_add(GTK_PACKER(mgpack), mongenbf, GTK_SIDE_LEFT, GTK_ANCHOR_CENTER, (GtkPackerOptions) (GTK_FILL_X | GTK_EXPAND), 0, 0, 0, 0, 0);
	gtk_box_pack_start(GTK_BOX(GNOME_DRUID_PAGE_STANDARD(fmpage)->vbox), mgpack, 0, 0, 0);
	gtk_signal_connect(GTK_OBJECT(fmpage), "cancel", GTK_SIGNAL_FUNC(&gm_close), NULL);
	gnome_druid_append_page(GNOME_DRUID(druid), GNOME_DRUID_PAGE(fmpage));
	finishpage = gnome_druid_page_finish_new_with_vals("Player Setup Complete", "Your new player profile has been set up.\nClick finish to generate these new settings.", 0, 0);
	gtk_signal_connect(GTK_OBJECT(finishpage), "cancel", GTK_SIGNAL_FUNC(&gm_close), NULL);
	gtk_signal_connect(GTK_OBJECT(finishpage), "finish", GTK_SIGNAL_FUNC(&gm_finish), NULL);
	gnome_druid_append_page(GNOME_DRUID(druid), GNOME_DRUID_PAGE(finishpage));
	gnome_druid_set_page(GNOME_DRUID(druid), GNOME_DRUID_PAGE(startpage));
	gtk_container_add(GTK_CONTAINER(window), druid);
	gtk_widget_show_all(window);
	while(close_out == FALSE)
		while(gtk_events_pending())
			gtk_main_iteration();
	gtk_widget_destroy(window);
	gnome_config_sync();
	return 0;
}
