
#include "gmonsters.h"
#include <stdlib.h>

#define GM_NOI 1

gboolean gm_item_recover(GMItemType, gpointer, gpointer, GtkWidget *);

// format is {type, name, noe, {{func, param}, ...}}
GMItem gm_items[GM_NOI] = { {GM_ITEM_ANY, "Potion", 1, {{&gm_item_recover, (gpointer) 50}}} };

GMItem *
gm_item_get_list()
{
	return gm_items;
}

guint
gm_item_list_length()
{
	return GM_NOI;
}

GMItem *
gm_item_match(gchar * name)
{
	guint a;
	for (a = 0; a < GM_NOI; a++)
		if (!strcmp(gm_items[a].name, name))
			return gm_items + a;
	return 0;
}

gboolean
gm_item_normal_use(gchar * name, gpointer o)
{
	GMItem *item = gm_item_match(name);
	GMTrainer *trn = (GMTrainer *) o;
	GMMonster *mon = gm_trainer_player_select(trn);
	if (item->noe > 0 && item->type != GM_ITEM_BATTLE && mon != NULL) {
		gboolean rv = FALSE;
		guint a;
		for (a = 0; a < item->noe; a++)
			if (item->effects[a].func(GM_ITEM_NORMAL, item->effects[a].param, mon, NULL) == TRUE)
				rv = TRUE;
		if (rv == FALSE)
			gnome_dialog_run(GNOME_DIALOG(gnome_ok_dialog("It wouldn't have any effect.")));
		return rv;
	} else if (item->type == GM_ITEM_BATTLE) {
		gnome_dialog_run(GNOME_DIALOG(gnome_ok_dialog("You can't use that here.")));
		return FALSE;
	}
	if(mon != NULL)
		gnome_dialog_run(GNOME_DIALOG(gnome_ok_dialog("It doesn't seem to do anything.")));
	else
		gnome_dialog_run(GNOME_DIALOG(gnome_ok_dialog("You didn't select a monster or don't have any active.")));
	return FALSE;
}

gboolean
gm_item_battle_use(gchar * name, gpointer o, GtkWidget * text)
{
	GMItem *item = gm_item_match(name);
	GMBattleEffects *one = (GMBattleEffects *) o;
	GMTrainer *trn = one->trainer;
	GMMonster *mon = (item->type == GM_ITEM_BATTLE ? one->monster : gm_trainer_player_select(trn));
	gchar *strng;
	if (item->noe > 0 && item->type != GM_ITEM_NORMAL) {
		gboolean rv = FALSE;
		guint a;
		for (a = 0; a < item->noe; a++)
			if (item->effects[a].func(GM_ITEM_BATTLE, item->effects[a].param, mon, text) == TRUE)
				rv = TRUE;
		strng = "It wouldn't have any effect.";
		if (rv == FALSE)
			gtk_text_insert(GTK_TEXT(text), 0, 0, 0, strng, strlen(strng));
		return rv;
	} else if (item->type == GM_ITEM_NORMAL) {
		strng = "You can't use that here.";
		gtk_text_insert(GTK_TEXT(text), 0, 0, 0, strng, strlen(strng));
		return FALSE;
	}
	strng = "It doesn't seem to do anything.";
	gtk_text_insert(GTK_TEXT(text), 0, 0, 0, strng, strlen(strng));
	return FALSE;
}

gboolean
gm_item_recover(GMItemType type, gpointer param, gpointer o, GtkWidget * text)
{
	GMMonster *mon = (GMMonster *) o;
	guint recov = ((guint) param + mon->hp > gm_monster_maxhp(mon, 0) ? gm_monster_maxhp(mon, 0) - mon->hp : (guint) param);
	gchar *strng = g_strdup_printf("%s recovered %u Health.", mon->name, recov);
	if (recov > 0) {
		mon->hp += recov;
		if (type == GM_ITEM_NORMAL)
			gnome_dialog_run(GNOME_DIALOG(gnome_ok_dialog(strng)));
		else
			gtk_text_insert(GTK_TEXT(text), 0, 0, 0, strng, strlen(strng));
		free(strng);
		return TRUE;
	}
	free(strng);
	return FALSE;
}
