
#include <gnome.h>
#include <libgnomeui/gnome-window-icon.h>
#include "gmonsters.h"
#include "filedirs.h"

static void gm_newuser();
static void gm_manager();
static void gm_battle();
static void gm_shop();
void gmnewuser_main();
void gmmanager_main();
void gmbattle_main();
//void gmshop_main();

GtkWidget *window;

int
main(int argc, char **argv)
{
	GtkWidget *vbox;
	GtkWidget *newuser;
	GtkWidget *manager;
	GtkWidget *battle;
	GtkWidget *shop;
	GtkWidget *quit;
	gnome_init("Gmonsters", "0.0.1", argc, argv);
	gm_init();
	gnome_window_icon_init();
	window = gnome_app_new("Gmonsters", "GMonsters: Main");
	gnome_window_icon_set_default_from_file(gm_pixmap_file("gnome-gmonsters.png"));
	vbox = gtk_vbox_new(TRUE, 0);
	newuser = gtk_button_new_with_label("Start New Game");
	manager = gtk_button_new_with_label("Trainer Manager");
	battle = gtk_button_new_with_label("Battle Monsters");
	shop = gtk_button_new_with_label("Item & Monster Shop");
	gtk_widget_set_sensitive(shop, FALSE);
	quit = gtk_button_new_with_label("Quit GMonsters");
	gtk_box_pack_start(GTK_BOX(vbox), newuser, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), manager, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), battle, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), shop, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), quit, FALSE, FALSE, 0);
	gnome_app_set_contents(GNOME_APP(window), vbox);
	gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(&gtk_main_quit), NULL);
	gtk_signal_connect(GTK_OBJECT(newuser), "clicked", GTK_SIGNAL_FUNC(&gm_newuser), NULL);
	gtk_signal_connect(GTK_OBJECT(manager), "clicked", GTK_SIGNAL_FUNC(&gm_manager), NULL);
	gtk_signal_connect(GTK_OBJECT(battle), "clicked", GTK_SIGNAL_FUNC(&gm_battle), NULL);
	gtk_signal_connect(GTK_OBJECT(shop), "clicked", GTK_SIGNAL_FUNC(&gm_shop), NULL);
	gtk_signal_connect(GTK_OBJECT(quit), "clicked", GTK_SIGNAL_FUNC(&gtk_main_quit), NULL);
	gtk_widget_show_all(window);
	gtk_main();
	return 0;
}

static void
gm_newuser()
{
	gtk_widget_hide(window);
	gmnewuser_main();
	gtk_widget_show_all(window);
}

static void
gm_manager()
{
	gtk_widget_hide(window);
	gmmanager_main();
	gtk_widget_show_all(window);
}

static void
gm_battle()
{
	gtk_widget_hide(window);
	gmbattle_main();
	gtk_widget_show_all(window);
}

static void
gm_shop()
{
	gtk_widget_hide(window);
//	gmshop_main();
	gtk_widget_show_all(window);
}
