
#include "gmonsters.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

GMTrainer *
gm_trainer_new()
{
	GMTrainer *trainer = malloc(sizeof(GMTrainer));
	trainer->name = g_strdup("Trainer");
	trainer->money = 750;
	trainer->nom = 0;
	trainer->monsters = NULL;
	trainer->noi = 0;
	trainer->items = NULL;
	trainer->skill.normal = 20;
	trainer->skill.stone = 20;
	trainer->skill.flying = 20;
	trainer->skill.electric = 20;
	trainer->skill.water = 20;
	trainer->skill.fire = 20;
	trainer->skill.poison = 20;
	trainer->skill.insect = 20;
	trainer->skill.plant = 20;
	trainer->skill.fighting = 20;
	trainer->skill.psychic = 20;
	trainer->skill.fungus = 20;
	trainer->skill.nocturnal = 20;
	trainer->skill.cybernetic = 20;
	trainer->skill.ice = 20;
	trainer->skill.energy = 20;
	trainer->skill.ghost = 20;
	return trainer;
}

GMTrainer *
gm_trainer_load(FILE * fp)
{
	GMTrainer *trainer = malloc(sizeof(GMTrainer));
	guint a, len;
	fread(&trainer->money, sizeof(guint), 1, fp);
	fread(&len, sizeof(guint), 1, fp);
	trainer->name = malloc(sizeof(gchar) * len);
	fread(trainer->name, sizeof(gchar), len, fp);
	fread(&trainer->skill, sizeof(GMSkillLevel), 1, fp);
	fread(&trainer->nom, sizeof(guint), 1, fp);
	trainer->monsters = malloc(sizeof(GMMonsterList *) * trainer->nom);
	for (a = 0; a < trainer->nom; a++) {
		trainer->monsters[a] = malloc(sizeof(GMMonsterList));
		fread(&trainer->monsters[a]->active, sizeof(gboolean), 1, fp);
		fread(&len, sizeof(guint), 1, fp);
		trainer->monsters[a]->name = malloc(sizeof(gchar) * len);
		fread(trainer->monsters[a]->name, sizeof(gchar), len, fp);
		fread(&trainer->monsters[a]->id, sizeof(gulong), 1, fp);
	}
	fread(&trainer->noi, sizeof(guint), 1, fp);
	if (trainer->noi > 0) {
		trainer->items = malloc(sizeof(GMItemList *) * trainer->noi);
		for (a = 0; a < trainer->noi; a++) {
			trainer->items[a] = malloc(sizeof(GMItemList));
			fread(&trainer->items[a]->num, sizeof(guint), 1, fp);
			fread(&len, sizeof(guint), 1, fp);
			trainer->items[a]->name = malloc(sizeof(gchar) * len);
			fread(trainer->items[a]->name, sizeof(gchar), len, fp);
		}
	}
	trainer->monselect = &gm_trainer_ai_select;
	trainer->itemselect = &gm_trainer_item_ai_select;
	return trainer;
}

GMTrainer *
gm_trainer_load_net()
{
	GMTrainer *trainer = malloc(sizeof(GMTrainer));
	guint a, len;
	read(gm_net_opponent(), &trainer->money, sizeof(guint));
	read(gm_net_opponent(), &len, sizeof(guint));
	trainer->name = malloc(sizeof(gchar) * len);
	read(gm_net_opponent(), trainer->name, sizeof(gchar) * len);
	read(gm_net_opponent(), &trainer->skill, sizeof(GMSkillLevel));
	read(gm_net_opponent(), &trainer->nom, sizeof(guint));
	trainer->monsters = malloc(sizeof(GMMonsterList *) * trainer->nom);
	for (a = 0; a < trainer->nom; a++) {
		trainer->monsters[a] = malloc(sizeof(GMMonsterList));
		read(gm_net_opponent(), &trainer->monsters[a]->active, sizeof(gboolean));
		read(gm_net_opponent(), &len, sizeof(guint));
		trainer->monsters[a]->name = malloc(sizeof(gchar) * len);
		read(gm_net_opponent(), trainer->monsters[a]->name, sizeof(gchar) * len);
		read(gm_net_opponent(), &trainer->monsters[a]->id, sizeof(gulong));
	}
	read(gm_net_opponent(), &trainer->noi, sizeof(guint));
	if (trainer->noi > 0) {
		trainer->items = malloc(sizeof(GMItemList *) * trainer->noi);
		for (a = 0; a < trainer->noi; a++) {
			trainer->items[a] = malloc(sizeof(GMItemList));
			read(gm_net_opponent(), &trainer->items[a]->num, sizeof(guint));
			read(gm_net_opponent(), &len, sizeof(guint));
			trainer->items[a]->name = malloc(sizeof(gchar) * len);
			read(gm_net_opponent(), trainer->items[a]->name, sizeof(gchar) * len);
		}
	}
	trainer->monselect = &gm_trainer_net_select;
	trainer->itemselect = &gm_trainer_item_net_select;
	return trainer;
}

void
gm_trainer_save(FILE * fp, GMTrainer * trainer)
{
	guint a;
	guint len = strlen(trainer->name) + 1;
	fwrite(&trainer->money, sizeof(guint), 1, fp);
	fwrite(&len, sizeof(guint), 1, fp);
	fwrite(trainer->name, sizeof(gchar), len, fp);
	fwrite(&trainer->skill, sizeof(GMSkillLevel), 1, fp);
	fwrite(&trainer->nom, sizeof(guint), 1, fp);
	for (a = 0; a < trainer->nom; a++) {
		len = strlen(trainer->monsters[a]->name) + 1;
		fwrite(&trainer->monsters[a]->active, sizeof(gboolean), 1, fp);
		fwrite(&len, sizeof(guint), 1, fp);
		fwrite(trainer->monsters[a]->name, sizeof(gchar), len, fp);
		fwrite(&trainer->monsters[a]->id, sizeof(gulong), 1, fp);
		gm_monster_close(trainer->monsters[a]->id);
	}
	fwrite(&trainer->noi, sizeof(guint), 1, fp);
	if (trainer->noi > 0) {
		for (a = 0; a < trainer->noi; a++) {
			len = strlen(trainer->items[a]->name) + 1;
			fwrite(&trainer->items[a]->num, sizeof(guint), 1, fp);
			fwrite(&len, sizeof(guint), 1, fp);
			fwrite(trainer->items[a]->name, sizeof(gchar), len, fp);
		}
	}
}

void
gm_trainer_send_net(GMTrainer * trainer)
{
	guint a;
	guint len = strlen(trainer->name) + 1;
	write(gm_net_opponent(), &trainer->money, sizeof(guint));
	write(gm_net_opponent(), &len, sizeof(guint));
	write(gm_net_opponent(), trainer->name, sizeof(gchar) * len);
	write(gm_net_opponent(), &trainer->skill, sizeof(GMSkillLevel));
	write(gm_net_opponent(), &trainer->nom, sizeof(guint));
	for (a = 0; a < trainer->nom; a++) {
		len = strlen(trainer->monsters[a]->name) + 1;
		write(gm_net_opponent(), &trainer->monsters[a]->active, sizeof(gboolean));
		write(gm_net_opponent(), &len, sizeof(guint));
		write(gm_net_opponent(), trainer->monsters[a]->name, sizeof(gchar) * len);
		write(gm_net_opponent(), &trainer->monsters[a]->id, sizeof(gulong));
		gm_monster_close(trainer->monsters[a]->id);
	}
	write(gm_net_opponent(), &trainer->noi, sizeof(guint));
	if (trainer->noi > 0) {
		for (a = 0; a < trainer->noi; a++) {
			len = strlen(trainer->items[a]->name) + 1;
			write(gm_net_opponent(), &trainer->items[a]->num, sizeof(guint));
			write(gm_net_opponent(), &len, sizeof(guint));
			write(gm_net_opponent(), trainer->items[a]->name, sizeof(gchar) * len);
		}
	}
}

guint
gm_trainer_skill(GMTrainer * trn, GMClassification type)
{
	guint num = 0, rv = 0;
	if (type & GM_STONE) {
		rv += trn->skill.stone;
		num++;
	}
	if (type & GM_FLYING) {
		rv += trn->skill.flying;
		num++;
	}
	if (type & GM_ELECTRIC) {
		rv += trn->skill.electric;
		num++;
	}
	if (type & GM_WATER) {
		rv += trn->skill.water;
		num++;
	}
	if (type & GM_FIRE) {
		rv += trn->skill.fire;
		num++;
	}
	if (type & GM_POISON) {
		rv += trn->skill.poison;
		num++;
	}
	if (type & GM_INSECT) {
		rv += trn->skill.insect;
		num++;
	}
	if (type & GM_PLANT) {
		rv += trn->skill.plant;
		num++;
	}
	if (type & GM_FIGHTING) {
		rv += trn->skill.fighting;
		num++;
	}
	if (type & GM_PSYCHIC) {
		rv += trn->skill.psychic;
		num++;
	}
	if (type & GM_FUNGUS) {
		rv += trn->skill.fungus;
		num++;
	}
	if (type & GM_NOCTURNAL) {
		rv += trn->skill.nocturnal;
		num++;
	}
	if (type & GM_CYBERNETIC) {
		rv += trn->skill.cybernetic;
		num++;
	}
	if (type & GM_ICE) {
		rv += trn->skill.ice;
		num++;
	}
	if (type & GM_ENERGY) {
		rv += trn->skill.energy;
		num++;
	}
	if (type & GM_GHOST) {
		rv += trn->skill.ghost;
		num++;
	}
	if (num > 0)
		rv = rv / num;
	else
		rv = trn->skill.normal;
	return rv;
}

void
gm_trainer_raise_skill(GMTrainer * trn, GMClassification type)
{
	guint num = 0;
	if (type & GM_STONE && trn->skill.stone < 100) {
		trn->skill.stone++;
		num++;
	}
	if (type & GM_FLYING && trn->skill.flying < 100) {
		trn->skill.flying++;
		num++;
	}
	if (type & GM_ELECTRIC && trn->skill.electric < 100) {
		trn->skill.electric++;
		num++;
	}
	if (type & GM_WATER && trn->skill.water < 100) {
		trn->skill.water++;
		num++;
	}
	if (type & GM_FIRE && trn->skill.fire < 100) {
		trn->skill.fire++;
		num++;
	}
	if (type & GM_POISON && trn->skill.poison < 100) {
		trn->skill.poison++;
		num++;
	}
	if (type & GM_INSECT && trn->skill.insect < 100) {
		trn->skill.insect++;
		num++;
	}
	if (type & GM_PLANT && trn->skill.plant < 100) {
		trn->skill.plant++;
		num++;
	}
	if (type & GM_FIGHTING && trn->skill.fighting < 100) {
		trn->skill.fighting++;
		num++;
	}
	if (type & GM_PSYCHIC && trn->skill.psychic < 100) {
		trn->skill.psychic++;
		num++;
	}
	if (type & GM_FUNGUS && trn->skill.fungus < 100) {
		trn->skill.fungus++;
		num++;
	}
	if (type & GM_NOCTURNAL && trn->skill.nocturnal < 100) {
		trn->skill.nocturnal++;
		num++;
	}
	if (type & GM_CYBERNETIC && trn->skill.cybernetic < 100) {
		trn->skill.cybernetic++;
		num++;
	}
	if (type & GM_ICE && trn->skill.ice < 100) {
		trn->skill.ice++;
		num++;
	}
	if (type & GM_ENERGY && trn->skill.energy < 100) {
		trn->skill.energy++;
		num++;
	}
	if (type & GM_GHOST && trn->skill.ghost < 100) {
		trn->skill.ghost++;
		num++;
	}
	if (num == 0)
		trn->skill.normal++;
}

void
gm_trainer_lower_skill(GMTrainer * trn, GMClassification type)
{
	guint num = 0;
	if (type & GM_STONE && trn->skill.stone > 0) {
		trn->skill.stone--;
		num++;
	}
	if (type & GM_FLYING && trn->skill.flying > 0) {
		trn->skill.flying--;
		num++;
	}
	if (type & GM_ELECTRIC && trn->skill.electric > 0) {
		trn->skill.electric--;
		num++;
	}
	if (type & GM_WATER && trn->skill.water > 0) {
		trn->skill.water--;
		num++;
	}
	if (type & GM_FIRE && trn->skill.fire > 0) {
		trn->skill.fire--;
		num++;
	}
	if (type & GM_POISON && trn->skill.poison > 0) {
		trn->skill.poison--;
		num++;
	}
	if (type & GM_INSECT && trn->skill.insect > 0) {
		trn->skill.insect--;
		num++;
	}
	if (type & GM_PLANT && trn->skill.plant > 0) {
		trn->skill.plant--;
		num++;
	}
	if (type & GM_FIGHTING && trn->skill.fighting > 0) {
		trn->skill.fighting--;
		num++;
	}
	if (type & GM_PSYCHIC && trn->skill.psychic > 0) {
		trn->skill.psychic--;
		num++;
	}
	if (type & GM_FUNGUS && trn->skill.fungus > 0) {
		trn->skill.fungus--;
		num++;
	}
	if (type & GM_NOCTURNAL && trn->skill.nocturnal > 0) {
		trn->skill.nocturnal--;
		num++;
	}
	if (type & GM_CYBERNETIC && trn->skill.cybernetic > 0) {
		trn->skill.cybernetic--;
		num++;
	}
	if (type & GM_ICE && trn->skill.ice > 0) {
		trn->skill.ice--;
		num++;
	}
	if (type & GM_ENERGY && trn->skill.energy > 0) {
		trn->skill.energy--;
		num++;
	}
	if (type & GM_GHOST && trn->skill.ghost > 0) {
		trn->skill.ghost--;
		num++;
	}
	if (num == 0)
		trn->skill.normal--;
}

void
gm_trainer_add_monster(GMTrainer * trn, GMMonster * mon)
{
	GMMonsterList **tmp = trn->monsters;
	guint a;
	trn->nom++;
	trn->monsters = malloc(sizeof(GMMonsterList *) * trn->nom);
	trn->monsters[trn->nom - 1] = malloc(sizeof(GMMonsterList));
	trn->monsters[trn->nom - 1]->active = FALSE;
	trn->monsters[trn->nom - 1]->name = g_strdup(mon->name);
	trn->monsters[trn->nom - 1]->id = mon->id;
	if (tmp != NULL) {
		for (a = 0; a < trn->nom - 1; a++)
			trn->monsters[a] = tmp[a];
		free(tmp);
	}
	if (!strcmp(mon->tamer, "Wild (Not tamed)")) {
		free(mon->tamer);
		mon->tamer = g_strdup(trn->name);
	}
	if (trn == gm_trainer) {
		FILE *fp = fopen(gnome_util_home_file("gmtrainer"), "w");
		gm_trainer_save(fp, trn);
		fclose(fp);
	}
}

void
gm_trainer_remove_monster(GMTrainer * trn, gulong id)
{
	GMMonsterList **tmp = trn->monsters;
	guint a, num = 0;
	for (a = 0; a < trn->nom; a++)
		if (trn->monsters[a]->id == id)
			num = a + 1;
	if (num > 0) {
		trn->nom--;
		trn->monsters = malloc(sizeof(GMMonsterList *) * trn->nom);
		for (a = 0; a < num - 1; a++)
			trn->monsters[a] = tmp[a];
		for (a = num; a < trn->nom + 1; a++)
			trn->monsters[a - 1] = tmp[a];
		free(tmp);
	}
	if (trn == gm_trainer) {
		FILE *fp = fopen(gnome_util_home_file("gmtrainer"), "w");
		gm_trainer_save(fp, trn);
		fclose(fp);
	}
}

void
gm_trainer_delete_monster(GMTrainer * trn, gulong id)
{
	GMMonsterList **tmp = trn->monsters;
	guint a, num = 0;
	for (a = 0; a < trn->nom; a++)
		if (trn->monsters[a]->id == id)
			num = a + 1;
	if (num > 0) {
		trn->nom--;
		trn->monsters = malloc(sizeof(GMMonsterList *) * trn->nom);
		for (a = 0; a < num - 1; a++)
			trn->monsters[a] = tmp[a];
		for (a = num; a < trn->nom + 1; a++)
			trn->monsters[a - 1] = tmp[a];
		free(tmp);
		gm_monster_destroy(id);
	}
	if (trn == gm_trainer) {
		FILE *fp = fopen(gnome_util_home_file("gmtrainer"), "w");
		gm_trainer_save(fp, trn);
		fclose(fp);
	}
}

void
gm_trainer_deactivate(GMTrainer * trn, gulong id)
{
	guint a;
	for (a = 0; a < trn->nom; a++)
		if (trn->monsters[a]->id == id)
			trn->monsters[a]->active = FALSE;
	if (trn == gm_trainer) {
		FILE *fp = fopen(gnome_util_home_file("gmtrainer"), "w");
		gm_trainer_save(fp, trn);
		fclose(fp);
	}
}

void
gm_trainer_select_cb(GtkWidget * mlist, guint row, guint col)
{
	*((GMMonsterList **) gtk_object_get_user_data(GTK_OBJECT(mlist))) = (GMMonsterList *) gtk_clist_get_row_data(GTK_CLIST(mlist), row);
}

void
gm_trainer_ok_cb(GtkWidget * w, guint * clicked)
{
	*clicked = 1;
}

void
gm_trainer_cancel_cb(GtkWidget * w, guint * clicked)
{
	*clicked = 2;
}

GMMonster *
gm_trainer_player_select(GMTrainer * trn)
{
	gchar *titles[1] = { "Monster" };
	GtkWidget *dialog = gnome_dialog_new("GMonsters: Select Monster", GNOME_STOCK_BUTTON_OK,
										 GNOME_STOCK_BUTTON_CANCEL, NULL);
	GtkWidget *mlist = gtk_clist_new_with_titles(1, titles);
	GMMonsterList *pmon = NULL;
	guint clicked = 0, a;
	gtk_clist_clear(GTK_CLIST(mlist));
	gtk_object_set_user_data(GTK_OBJECT(mlist), &pmon);
	for (a = 0; a < trn->nom; a++) {
		gchar *name[1] = { trn->monsters[a]->name };
		guint b;
		if (trn->monsters[a]->active == TRUE) {
			b = gtk_clist_append(GTK_CLIST(mlist), name);
			gtk_clist_set_row_data(GTK_CLIST(mlist), b, trn->monsters[a]);
		}
	}
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), mlist, 0, 0, 0);
	gtk_signal_connect(GTK_OBJECT(mlist), "select_row", GTK_SIGNAL_FUNC(&gm_trainer_select_cb), NULL);
	gnome_dialog_button_connect(GNOME_DIALOG(dialog), 0, GTK_SIGNAL_FUNC(&gm_trainer_ok_cb), &clicked);
	gnome_dialog_button_connect(GNOME_DIALOG(dialog), 1, GTK_SIGNAL_FUNC(&gm_trainer_cancel_cb), &clicked);
	if (GTK_CLIST(mlist)->rows > 0) {
		gtk_widget_show_all(dialog);
		while (clicked == 0 || (clicked == 1 && pmon == NULL)) {
			gtk_main_iteration();
			if (clicked == 1 && pmon == NULL) {
				clicked = 0;
			}
		}
	}
	gtk_widget_destroy(dialog);
	if (gm_net_opponent()) {
		gulong rv = (clicked == 1) ? pmon->id : 0;
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing monster to opponent...\n", getpid(), __LINE__);
		write(gm_net_opponent(), &rv, sizeof(gulong));
		gm_net_wait_write();
		if(rv != 0) {
			gm_monster_send_net(rv);
			gm_net_wait_write();
		}
	}
	if (clicked == 1)
		return gm_monster_open(pmon->id);
	return 0;
}

GMMonster *
gm_trainer_ai_select(GMTrainer * trn)
{
	guint a, none = 0;
	for (a = 0; a < trn->nom; a++)
		if (trn->monsters[a]->active == FALSE)
			none++;
	if (none < trn->nom) {
		while(1) {
			guint rnd = rand() % trn->nom;
			if (trn->monsters[rnd]->active == TRUE) {
				if (gm_net_opponent()) {
					gulong rv = trn->monsters[rnd]->id;
					fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing monster to opponent...\n", getpid(), __LINE__);
					write(gm_net_opponent(), &rv, sizeof(gulong));
					gm_net_wait_write();
					gm_monster_send_net(rv);
					gm_net_wait_write();
				}
				return gm_monster_open(trn->monsters[rnd]->id);
			}
		}
	}
	if (gm_net_opponent()) {
		gulong rv = 0;
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing monster to opponent...\n", getpid(), __LINE__);
		write(gm_net_opponent(), &rv, sizeof(gulong));
		gm_net_wait_write();
	}
	return 0;
}

void
gm_trainer_add_item(GMTrainer * trn, GMItem * item, guint num)
{
	GMItemList **tmp = trn->items;
	GMItemList *itemhave = NULL;
	guint a;
	for (a = 0; a < trn->noi; a++)
		if (!strcmp(item->name, trn->items[a]->name))
			itemhave = trn->items[a];
	if (itemhave != NULL)
		itemhave->num += num;
	else {
		trn->noi++;
		trn->items = malloc(sizeof(GMItemList *) * trn->noi);
		trn->items[trn->noi - 1] = malloc(sizeof(GMItemList));
		trn->items[trn->noi - 1]->num = num;
		trn->items[trn->noi - 1]->name = g_strdup(item->name);
		if (tmp != NULL) {
			for (a = 0; a < trn->nom - 1; a++)
				trn->items[a] = tmp[a];
			free(tmp);
		}
	}
	if (trn == gm_trainer) {
		FILE *fp = fopen(gnome_util_home_file("gmtrainer"), "w");
		gm_trainer_save(fp, trn);
		fclose(fp);
	}
}

gboolean
gm_trainer_remove_item(GMTrainer * trn, gchar * name, guint ntd)
{
	GMItemList **tmp = trn->items;
	guint a, num = 0;
	for (a = 0; a < trn->noi; a++)
		if (!strcmp(trn->items[a]->name, name))
			num = a + 1;
	if (num > 0) {
		if (trn->items[num - 1]->num > ntd)
			trn->items[num - 1]->num -= ntd;
		else if (trn->items[num - 1]->num == ntd) {
			trn->noi--;
			trn->items = malloc(sizeof(GMItemList *) * trn->noi);
			for (a = 0; a < num - 1; a++)
				trn->items[a] = tmp[a];
			for (a = num; a < trn->noi + 1; a++)
				trn->items[a - 1] = tmp[a];
			free(tmp);
		} else
			return FALSE;
	} else
		return FALSE;
	if (trn == gm_trainer) {
		FILE *fp = fopen(gnome_util_home_file("gmtrainer"), "w");
		gm_trainer_save(fp, trn);
		fclose(fp);
	}
	return TRUE;
}

void
gm_trainer_item_select_cb(GtkWidget * ilist, guint row, guint col, GdkEvent * ev, guint * r)
{
	*r = row;
	*((GMItemList **) gtk_object_get_user_data(GTK_OBJECT(ilist))) = (GMItemList *) gtk_clist_get_row_data(GTK_CLIST(ilist), row);
}

void
gm_trainer_item_ok_cb(GtkWidget * w, guint * clicked)
{
	*clicked = 1;
}

void
gm_trainer_item_cancel_cb(GtkWidget * w, guint * clicked)
{
	*clicked = 2;
}

GMItemList *
gm_trainer_item_player_select(GMTrainer * trn)
{
	gchar *titles[2] = { "Item", "Num" };
	GtkWidget *dialog = gnome_dialog_new("GMonsters: Select Item", GNOME_STOCK_BUTTON_OK,
										 GNOME_STOCK_BUTTON_CANCEL, NULL);
	GtkWidget *ilist = gtk_clist_new_with_titles(2, titles);
	GMItemList *pitem = NULL;
	guint clicked = 0, a, row = 0;
	gtk_clist_clear(GTK_CLIST(ilist));
	gtk_object_set_user_data(GTK_OBJECT(ilist), &pitem);
	for (a = 0; a < trn->noi; a++) {
		gchar *name[2] = { trn->items[a]->name, g_strdup_printf("%u",
																trn->items[a]->num)
		};
		guint b;
		b = gtk_clist_append(GTK_CLIST(ilist), name);
		gtk_clist_set_row_data(GTK_CLIST(ilist), b, trn->items[a]);
		free(name[1]);
	}
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), ilist, 0, 0, 0);
	gtk_signal_connect(GTK_OBJECT(ilist), "select_row", GTK_SIGNAL_FUNC(&gm_trainer_item_select_cb), &row);
	gnome_dialog_button_connect(GNOME_DIALOG(dialog), 0, GTK_SIGNAL_FUNC(&gm_trainer_item_ok_cb), &clicked);
	gnome_dialog_button_connect(GNOME_DIALOG(dialog), 1, GTK_SIGNAL_FUNC(&gm_trainer_item_cancel_cb), &clicked);
	if (GTK_CLIST(ilist)->rows > 0) {
		gtk_widget_show_all(dialog);
		while (clicked == 0 || (clicked == 1 && pitem == NULL)) {
			gtk_main_iteration();
			if (clicked == 1 && pitem == NULL) {
				clicked = 0;
			}
		}
	}
	gtk_widget_destroy(dialog);
	if (gm_net_opponent()) {
		guint rv = (clicked == 1) ? row + 1 : 0;
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing item to opponent...\n", getpid(), __LINE__);
		write(gm_net_opponent(), &rv, sizeof(guint));
		gm_net_wait_write();
	}
	if (clicked == 1)
		return pitem;
	return 0;
}

GMItemList *
gm_trainer_item_ai_select(GMTrainer * trn)
{
	if (trn->noi > 0) {
		guint rnd = rand() % trn->noi;
		if (gm_net_opponent()) {
			fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing item to opponent...\n", getpid(), __LINE__);
			write(gm_net_opponent(), &rnd, sizeof(guint));
			gm_net_wait_write();
		}
		return trn->items[rnd];
	}
	if (gm_net_opponent()) {
		guint rv = 0;
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Writing no item to opponent...\n", getpid(), __LINE__);
		write(gm_net_opponent(), &rv, sizeof(guint));
		gm_net_wait_write();
	}
	return 0;
}

GMMonster *
gm_trainer_net_select(GMTrainer * trn)
{
	gulong rv = 0;
	if (gm_net_opponent()) {
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Reading monster from opponent...\n", getpid(), __LINE__);
		gm_net_wait();
		read(gm_net_opponent(), &rv, sizeof(gulong));
	}
	if(rv == 0)
		return NULL;
	return gm_monster_open_net(rv);
}

GMItemList *
gm_trainer_item_net_select(GMTrainer * trn)
{
	guint rv = 0;
	if (gm_net_opponent()) {
		fprintf(stderr, "Proccess %d: " __FILE__ ": %d: Reading item from opponent...\n", getpid(), __LINE__);
		gm_net_wait();
		read(gm_net_opponent(), &rv, sizeof(guint));
	}
	if (rv > 0)
		return trn->items[rv - 1];
	return 0;
}

GMMonster *
gm_trainer_select_monster(GMTrainer * trn)
{
	return trn->monselect(trn);
}

GMItemList *
gm_trainer_select_item(GMTrainer * trn)
{
	return trn->itemselect(trn);
}
